#!/bin/sh

PATH=/var/log/copfilter/default/opt/sqlite/default/bin:/sbin:/usr/sbin:/usr/local/sbin:/bin:/usr/bin:/usr/local/bin
. /var/log/copfilter/default/etc/global_settings
. /var/ipcop/main/settings
. /var/log/copfilter/default/langs/en.sh
. /var/log/copfilter/default/langs/${LANGUAGE}.sh

RDJ_VERSION=0.03.0

if [ ! -d /tmp/sarules ]; then
	mkdir --mode=0777 /tmp/sarules >/dev/null 2>&1
fi

MPLOG=/tmp/mp.log
ZMILOG=/tmp/zmi.log
MIMVALLOG=/tmp/mimval.log
RULEDIR=$BASEDIR/opt/mail-spamassassin/etc/mail/spamassassin
WRITEFILE=`mktemp /tmp/writefile.XXXXXX`
REPLACEDIR="\/tmp\/sarules\/"
ISERROR=0
CFGFLG=0
TMP_FILE1a=$TMPDIR/rules_du_jour.tmp1a
TMP_FILE2a=$TMPDIR/rules_du_jour.tmp2a
TMP_FILE4=$TMPDIR/rules_du_jour.tmp4
BETREFF=""
SALOG=$BASEDIR/opt/tools/var/log/saupdate.log

rules_du_jour_sendmail(){

if [ "x${ISERROR}" = "x0" ]; then
	BETREFF="[Copfilter] AntiSpam Update: Rules Du Jour"
else
	BETREFF="[Copfilter] AntiSpam Update: ERROR"
fi

echo "=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-Update SpamAssassin-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=" > /tmp/tmp_file4
cat <<-EOF>> /tmp/tmp_file4
	
`cat $TMP_FILE4`
EOF
mv -fT /tmp/tmp_file4 $TMP_FILE4


cat $TMP_FILE4 | logger -t "copfilter updates spamassassin"
if [ -f $BASEDIR/etc/smtp_auth_enable ]; then
	echo "smtp authentication enabled, using user: $SMTP_AUTH_USER"
	cat $TMP_FILE4 | $SENDEMAIL -xu $SMTP_AUTH_USER -xp $SMTP_AUTH_PASS \
	-f $SENDER_ADR -t $EMAIL_ADR -s "${SMTP_HOST}"         \
	-u "$BETREFF" | logger -t "copfilter updates spamassassin"
else
	cat $TMP_FILE4 | $SENDEMAIL -f $SENDER_ADR -t $EMAIL_ADR -s "${SMTP_HOST}"         \
	-u "$BETREFF" | logger -t "copfilter updates spamassassin"
fi
}

if [ ! -f /var/ipcop/red/active ] ; then
   echo "no internet connection available, so no updates will be downloaded" |logger -t "copfilter updates spamassassin $APPEND"
   exit
fi

if [ "x${RULES_DU_JOUR_ENABLE}" = "xoff" ] ; then
   echo "will not update since rules_du_jour is ON" |logger -t "copfilter updates spamassassin $APPEND"
   exit
fi

if [ "x$1" = "xweboutput" ]; then
  APPEND="<BR>"
fi

echo "rules_du_jour updating ... " |logger -t "copfilter updates spamassassin"




echo "=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-Update SpamAssassin-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=" > $TMP_FILE4
echo >> $TMP_FILE4


      
        RESULT1=1

        # Update SPAMASSASSIN channel
        cd $RULEDIR/updates_spamassassin/updates_spamassassin_org
        ls -la --time-style=long-iso *.cf | sed -e 's/  */ /g' | cut -d " " -f 6- > $TMP_FILE1a
        if [ "x${SPAMD_ENABLE}" = "xon" ];then
            $BASEDIR/opt/mail-spamassassin/default/bin/sa-update --nogpg --allowplugins --channel updates.spamassassin.org --updatedir $RULEDIR/updates_spamassassin
            RESULT1=$?
        fi
        ls -la --time-style=long-iso *.cf | sed -e 's/  */ /g' | cut -d " " -f 6-  >$TMP_FILE2a


if [ "$(cat $TMP_FILE2a)" != "$(cat $TMP_FILE1a)" ]; then
	CFGFLG=1
	echo "updating SpamAssassin rules..."
	echo -e "update available from SpamAssassin rulesets:\n=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=\n" >> $TMP_FILE4
	echo $CP_rules_update_mail >> $TMP_FILE4
	echo >> $TMP_FILE4
	diff $TMP_FILE1a $TMP_FILE2a |sed -e '/</d' -e '/\,/d' -e '/---/d' -e 's/> //g' >> $TMP_FILE4
	echo >>  $TMP_FILE4 
#	echo >>  $TMP_FILE4 
#	echo "$CP_rules2" >> $TMP_FILE4 
#	ls -laR --time-style=long-iso [!l]*.cf >> $TMP_FILE4
#	echo >>  $TMP_FILE4 
	echo -e "=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=\n" >> $TMP_FILE4
else
	echo -e "no update available from SpamAssassin rulesets.\n=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=\n" >> $TMP_FILE4
fi


# This rules are von malwarepatrol.com.br and are only for non-commercial use
# downloaded only if the mod from karesmakro is installed
grep -i "^include updates_spamassassin/10_MBL.cf" $BASEDIR/opt/mail-spamassassin/etc/mail/spamassassin/local.cf >/dev/null 2>&1
if [ $? -eq 0 ]; then
	SOURCE="10_MBL.cf"
	wget -c -t 2 -T 120 -o $MPLOG -O - "http://www.malware.com.br/cgi/submit?action=list_sa" > /tmp/sarules/10_MBL.cf
	if [ `ls -l --time-style=long-iso /tmp/sarules/10_MBL.cf | sed -e 's/  */ /g' | cut -d " " -f5` = 0 ]; then
		rm -f /tmp/sarules/10_MBL.cf >/dev/null 2>&1
	fi



	if [ -f /tmp/sarules/10_MBL.cf ]; then
	    if [ "$(cat $BASEDIR/opt/mail-spamassassin/etc/mail/spamassassin/updates_spamassassin/10_MBL.cf)" = "$(cat /tmp/sarules/10_MBL.cf)" ]; then
       	 echo "no update available from malware patrol ruleset." >> $TMP_FILE4
	        if [ $CFGFLG != 1 ]; then
      		    	CFGFLG=0
	      	 fi
	    else
		echo "updating $SOURCE..."
		CFGFLG=1
		rsync -az /tmp/sarules/10_MBL.cf $BASEDIR/opt/mail-spamassassin/etc/mail/spamassassin/updates_spamassassin/10_MBL.cf
		echo -e "update available from malware patrol ruleset:\n=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=\n" >> $TMP_FILE4
		cat $MPLOG | sed -e '/^.*[0-9]s$/d' > $WRITEFILE
		mv -fT $WRITEFILE $MPLOG
		cat $MPLOG | sed \
		-e '/.*http.*/d' -e '/.*HTTP.*/d' -e '/.*Connecting.*/d' -e '/.*Resolving.*/d' \
		-e '/.*Length.*/d' -e '/.*Saving to.*/d' -e '/^$/d' -e '/.*K ...........*/d' \
		-e 's/.*(.*)\(.*\)/\1/' -e '/.*skipping.*/d' > $WRITEFILE
		mv -fT $WRITEFILE $MPLOG
		cat $MPLOG | sed \
		-e 's/.* - \(.*\)/\1/' -e 's/\(.*\)stdout\(.*\)/\1'"$REPLACEDIR"''"$SOURCE"'\2/' > $WRITEFILE
		mv -fT $WRITEFILE $MPLOG
		grep "not retrieving" $MPLOG >/dev/null 2>&1
		NRET=$?
		grep "nothing to do" $MPLOG >/dev/null 2>&1
		NTD=$?
		if [ $NRET -ne 0 -a $NTD -ne 0 ]; then
			cat <<-EOF>> $TMP_FILE4
								
			`cat $MPLOG`
			EOF
		fi
	    fi
	else
		echo -e "update failed from malware patrol ruleset!\n=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=\n" >> $TMP_FILE4
		grep -i "error" $MPLOG >/dev/null 2>&1
		if [ $? -eq 0 ]; then
			ISERROR=1
			cat <<-EOF>> $TMP_FILE4
			
			`cat $MPLOG`
			EOF
		fi
	fi
	echo -e "=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=\n" >> $TMP_FILE4

fi


# German ruleset (none false positive) if language settings are de
# downloaded only if the mod from karesmakro is installed
if [ ${LANGUAGE} = "de" ]; then
	grep -i "^include updates_spamassassin/70_zmi_german.cf" $BASEDIR/opt/mail-spamassassin/etc/mail/spamassassin/local.cf >/dev/null 2>&1
	if [ $? -eq 0 ]; then
		SOURCE="70_zmi_german.cf"
		wget -c -t 2 -T 120 -o $ZMILOG -O - "http://zmi.at/x/70_zmi_german.cf" > /tmp/sarules/70_zmi_german.cf
		if [ `ls -l --time-style=long-iso /tmp/sarules/70_zmi_german.cf | sed -e 's/  */ /g' | cut -d " " -f5` = 0 ]; then
			rm -f /tmp/sarules/70_zmi_german.cf >/dev/null 2>&1
		fi


		if [ -f /tmp/sarules/70_zmi_german.cf ]; then
		    if [ "$(cat $BASEDIR/opt/mail-spamassassin/etc/mail/spamassassin/updates_spamassassin/70_zmi_german.cf)" = "$(cat /tmp/sarules/70_zmi_german.cf)" ]; then
       		 echo "no update available from german zmi ruleset." >> $TMP_FILE4
		        if [ $CFGFLG != 1 ]; then
       	 	    	CFGFLG=0
       		 fi
		    else
			echo "updating $SOURCE..."
			CFGFLG=1
			rsync -az /tmp/sarules/70_zmi_german.cf $BASEDIR/opt/mail-spamassassin/etc/mail/spamassassin/updates_spamassassin/70_zmi_german.cf
			echo -e "update available from german zmi ruleset:\n=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=\n" >> $TMP_FILE4
			cat $ZMILOG | sed -e '/^.*[0-9]s$/d' > $WRITEFILE
			mv -fT $WRITEFILE $ZMILOG
			cat $ZMILOG | sed \
			-e '/.*http.*/d' -e '/.*HTTP.*/d' -e '/.*Connecting.*/d' -e '/.*Resolving.*/d' \
			-e '/.*Length.*/d' -e '/.*Saving to.*/d' -e '/^$/d' -e '/.*K ...........*/d' \
			-e 's/.*(.*)\(.*\)/\1/' -e '/.*skipping.*/d' > $WRITEFILE
			mv -fT $WRITEFILE $ZMILOG
			cat $ZMILOG | sed \
			-e 's/.* - \(.*\)/\1/' -e 's/\(.*\)stdout\(.*\)/\1'"$REPLACEDIR"''"$SOURCE"'\2/' > $WRITEFILE
			mv -fT $WRITEFILE $ZMILOG
			grep "not retrieving" $ZMILOG >/dev/null 2>&1
			NRET=$?
			grep "nothing to do" $ZMILOG >/dev/null 2>&1
			NTD=$?
			if [ $NRET -ne 0 -a $NTD -ne 0 ]; then
				cat <<-EOF>> $TMP_FILE4
									
				`cat $ZMILOG`
				EOF
			fi
		    fi
		else
			echo -e "update failed from german zmi ruleset!\n=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=\n" >> $TMP_FILE4
			grep -i "error" $ZMILOG >/dev/null 2>&1
			if [ $? -eq 0 ]; then
				ISERROR=1
				cat <<-EOF>> $TMP_FILE4
				
				`cat $ZMILOG`
				EOF
			fi
		fi
		echo -e "=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=\n" >> $TMP_FILE4
	fi
fi



# mime validation ruleset
# downloaded only if the mod from karesmakro is installed
grep -i "^include updates_spamassassin/mime_validate.cf" $BASEDIR/opt/mail-spamassassin/etc/mail/spamassassin/local.cf >/dev/null 2>&1
if [ $? -eq 0 ]; then
	SOURCE="mime_validate.cf"
	wget -c -t 2 -T 120 -o $MIMVALLOG -O - "http://www.nospamtoday.com/download/mime_validate.cf" > /tmp/sarules/mime_validate.cf
	if [ `ls -l --time-style=long-iso /tmp/sarules/mime_validate.cf | sed -e 's/  */ /g' | cut -d " " -f5` = 0 ]; then
		rm -f /tmp/sarules/mime_validate.cf >/dev/null 2>&1
	fi


	if [ -f /tmp/sarules/mime_validate.cf ]; then
		if [ "$(cat $BASEDIR/opt/mail-spamassassin/etc/mail/spamassassin/updates_spamassassin/mime_validate.cf)" = "$(cat /tmp/sarules/mime_validate.cf)" ]; then
			echo "no update available from mime validation ruleset." >> $TMP_FILE4
			if [ $CFGFLG != 1 ]; then
				CFGFLG=0
			fi
		else
			echo "updating $SOURCE..."
			CFGFLG=1
			rsync -az /tmp/sarules/mime_validate.cf $BASEDIR/opt/mail-spamassassin/etc/mail/spamassassin/updates_spamassassin/mime_validate.cf
			echo -e "update available from mime validation ruleset:\n=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=\n" >> $TMP_FILE4
			cat $MIMVALLOG | sed -e '/^.*[0-9]s$/d' > $WRITEFILE
			mv -fT $WRITEFILE $MIMVALLOG
			cat $MIMVALLOG | sed \
			-e '/.*http.*/d' -e '/.*HTTP.*/d' -e '/.*Connecting.*/d' -e '/.*Resolving.*/d' \
			-e '/.*Length.*/d' -e '/.*Saving to.*/d' -e '/^$/d' -e '/.*K ...........*/d' \
			-e 's/.*(.*)\(.*\)/\1/' -e '/.*skipping.*/d' > $WRITEFILE
			mv -fT $WRITEFILE $MIMVALLOG
			cat $MIMVALLOG | sed \
			-e 's/.* - \(.*\)/\1/' -e 's/\(.*\)stdout\(.*\)/\1'"$REPLACEDIR"''"$SOURCE"'\2/' > $WRITEFILE
			mv -fT $WRITEFILE $MIMVALLOG
			grep "not retrieving" $MIMVALLOG >/dev/null 2>&1
			NRET=$?
			grep "nothing to do" $MIMVALLOG >/dev/null 2>&1
			NTD=$?
			if [ $NRET -ne 0 -a $NTD -ne 0 ]; then
				cat <<-EOF>> $TMP_FILE4
									
				`cat $MIMVALLOG`
				EOF
			fi
		fi
	else
		echo -e "update failed from mime validation ruleset!\n=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=\n" >> $TMP_FILE4
		grep -i "error" $MIMVALLOG >/dev/null 2>&1
		if [ $? -eq 0 ]; then
			ISERROR=1
			cat <<-EOF>> $TMP_FILE4
			
			`cat $MIMVALLOG`
			EOF
		fi
	fi
	echo -e "=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=\n" >> $TMP_FILE4
fi



grep -i "copfilter" /etc/group >/dev/null 2>&1
if [ $? -eq 0 ]; then
	chown -R spam.copfilter $BASEDIR/opt/mail-spamassassin/etc/mail/spamassassin/updates_spamassassin/
else
	chown -R spam.spam $BASEDIR/opt/mail-spamassassin/etc/mail/spamassassin/updates_spamassassin/
fi

if [ "x${CFGFLG}" = "x1" ]; then
	echo "updates available:" |logger -t "copfilter updates spamassassin"

	if [ -f $BASEDIR/opt/tools/bin/score_restore.sh ]; then
		$BASEDIR/opt/tools/bin/score_restore.sh
		sleep 1
	fi

	/etc/rc.d/init.d/copfilter_spamd reload cronoutput | logger -t "copfilter updates spamassassin"

fi

cat $TMP_FILE4 | sed -e '/=-=-=/d' -e '/patrol ruleset:/,/MBL.cf/ { /^$/d }' \
-e '/zmi ruleset:/,/_german.cf/ { /^$/d }' -e '/validation ruleset:/,/validate.cf/ { /^$/d }' > /tmp/tmp_file4
mv -fT /tmp/tmp_file4 $TMP_FILE4


cat <<-EOF>> $TMP_FILE4
`date +[%Z]" "%F" "%T`
_______________________________________________________________________________________________________________________________
EOF

cat <<-EOF>> $SALOG
`cat $TMP_FILE4`
EOF


if [ "x${CFGFLG}" = "x1" -o "x${ISERROR}" = "x1" ]; then
	if [ "x${SMTP_HOST}" = "x" -o "x${EMAIL_ADR}" = "x" ] ; then
		echo "no email notification will be sent, since SMTP_HOST and/or EMAIL_ADR where not specified" | logger -t "copfilter updates spamassassin"
	else
		if [ "x$UPDATE_MAIL_NOTIF" = "xoff" ]; then
			echo "no email notification will be sent, since this feature will be enabled" | logger -t "copfilter updates spamassassin"
		elif [ "x$UPDATE_MAIL_NOTIF" = "xerror" -a "x$ISERROR" = "x1" ]; then
			rules_du_jour_sendmail
		elif [ "x$UPDATE_MAIL_NOTIF" = "xon" ]; then
			rules_du_jour_sendmail
		fi
	fi
else
  echo "no newer updates available" |logger -t "copfilter updates spamassassin"
fi


echo "done " |logger -t "copfilter updates spamassassin"


#cleanup
rm -f $TMP_FILE1a >/dev/null 2>&1
rm -f $TMP_FILE2a >/dev/null 2>&1
rm -f $TMP_FILE4 >/dev/null 2>&1
rm -f $MPLOG >/dev/null 2>&1
rm -f $ZMILOG >/dev/null 2>&1
rm -f $MIMVALLOG >/dev/null 2>&1
rm -f /tmp/writefile.* >/dev/null 2>&1
