#!/usr/bin/perl
#
# SmoothWall CGIs
#
# This code is distributed under the terms of the GPL
#
# (c) The SmoothWall Team
#
# $Id: copfilter.cgi,v 0.00.0.3 2005/03/15 mmadlener
#



use strict;
use IO::Socket;
# enable only the following on debugging purpose
#use warnings;
#use CGI::Carp 'fatalsToBrowser';

################################################################################
##   Definitions
################################################################################

require '/var/ipcop/general-functions.pl';
require "${General::swroot}/lang.pl";
require "${General::swroot}/header.pl";

my ($copfilter_swroot);
my %copfiltersettings=();
my %netsettings=();
my (%selected,%checked)=();
my $errormessage = '';
my $output = '';
my $sortorder = 2;
my $thrdp_clamav = system ('/bin/grep "THRDP_VERSION" /var/log/copfilter/default/etc/global_settings &>/dev/null 2>&1');
my $thrdp_privoxy = system ('/bin/grep "RULES_VERSION" /var/log/copfilter/default/etc/global_settings &>/dev/null 2>&1');
my $thrdp_sarules = system ('/bin/grep "RDJ_VERSION" /var/log/copfilter/default/opt/tools/bin/check-updates_rulesdujour.sh &>/dev/null 2>&1');
my $thrdp_mod_on = ''; 
my $pid = '';

$copfilter_swroot = '/var/log/copfilter/default';
&General::readhash("${General::swroot}/ethernet/settings", \%netsettings);
&General::readhash("${copfilter_swroot}/etc/global_settings", \%copfiltersettings);
#&General::writehash("/tmp/before_cgi", \%copfiltersettings);
&Header::getcgihash(\%copfiltersettings);

#testing
#my %copfiltersettings2=();
#&General::readhash("${copfilter_swroot}/etc/global_settings", \%copfiltersettings3);
#&Header::getcgihash(\%copfiltersettings2);
#&General::writehash("/tmp/after_cgi", \%copfiltersettings);
#&General::writehash("/tmp/cgi", \%copfiltersettings2);


&Header::showhttpheaders();
&Header::openpage('Copfilter', 1, '');


#sub copfilter_set_lang {

package Lang;

### Initialize language
%Lang::tr = ();
    our $language;
    my %settings = ();
    &General::readhash("${General::swroot}/main/settings", \%settings);
    $language = $settings{'LANGUAGE'};
    if ($language =~ /^(\w+)$/) {$language = $1;}
    do "${copfilter_swroot}/langs/en.pl";
    do "${copfilter_swroot}/langs/${language}.pl";
1;
#}
#
#copfilter_set_lang();






################################################################################
##   Substitutions
################################################################################

#added by sdio
use Encode;
use MIME::Base64;

sub sdio_decode($) {
	my $a = shift;
	if ($a =~ /^[^?]+\?([^?]+)\?.\?([^?]+)\?/) {
		my $e=$1;
		$a=decode_base64($2);
		Encode::from_to($a, "$e", "utf8");
#debug		print "$e :: $a <br>\n";
	}
return $a;
}


sub copfilter_start_log
{

	&Header::openbigbox('100%', 'left');
	&Header::openbox('100%', 'left', "$Lang::tr{'copfilter'}:");
	print "<H1>  $Lang::tr{'copfilter log'}: </H1>\n";
}

sub copfilter_stop_log
{
        print "<br /><br />";
        print "<A HREF='/cgi-bin/copfilter_status.cgi' > $Lang::tr{'copfilter back'} </A>\n";
        print "<br /><br />";

        &Header::closebox();
        &Header::closebigbox();
        &Header::closepage();
}


sub writehashsorted
{
        my $filename = $_[0];
        my $hash = $_[1];
        my ($var, $val);


        # write cgi vars to the file.
        open(FILE, ">${filename}") or die "Unable to write file $filename";
        flock FILE, 2;
        foreach $var (sort (keys %$hash))
        {
                $val = $hash->{$var};
                # Darren Critchley Jan 17, 2003 added the following because when submitting with a graphic, the x and y
                # location of the mouse are submitted as well, this was being written to the settings file causing
                # some serious grief! This skips the variable.x and variable.y
                if (!($var =~ /(.x|.y)$/)) {
                        if ($val =~ / /) {
                                $val = "\'$val\'"; }
                        if (!($var =~ /^ACTION/)) {
                                print FILE "${var}=${val}\n"; }
                }
        }
        close FILE;
}


sub downloadver
{
        my %proxysettings=();
        &General::readhash("${General::swroot}/proxy/settings", \%proxysettings);

        my $peer = 'www.copfilter.org';
        my $peerport = 80;

        if ($_=$proxysettings{'UPSTREAM_PROXY'}) {
        ($peer, $peerport) = (/^(?:[a-zA-Z ]+\:\/\/)?(?:[A-Za-z0-9\_\.\-]*?(?:\:[A-Za-z0-9\_\.\-]*?)?\@)?([a-zA-Z0-9\.\_\-]*?)(?:\:([0-9]{1,5}))?(?:\/.*?)?$/);
        }

        my $sock=();
        unless($sock = new IO::Socket::INET (PeerAddr => $peer, PeerPort => $peerport, Proto => 'tcp', Timeout => 5))
        {
                return 0;
        }


        my $GET_CMD;
        $GET_CMD  = "GET http://www.copfilter.org/LATEST-VERSION-V2 HTTP/1.1\r\n";
        $GET_CMD .= "Host: www.copfilter.org\r\n";
        $GET_CMD .= "Cache-Control: no-cache\r\n";
        $GET_CMD .= "Connection: close\r\n\r\n";
        print $sock "$GET_CMD";

        my $ret = '';
        while (<$sock>) {
                $ret .= $_; }
        close($sock);
        return $ret;
}

sub count_files
{
    my $dir = shift;
    my $ext = shift;

    my ($count, $file);

    $count = 0;
#    if (system ("ls " . $dir . " >/dev/null 2>&1") eq 0 )
    if (system ("ls " . $dir . " >>/tmp/count.aid 2>&1") eq 0 )
    {
       opendir(BIN, $dir) or die "Can't open $dir: $!";
       foreach my $file (grep {/\.$ext$/} readdir BIN)
       {
#!!!           $count++ if -T "$dir/$file";
# Above line did not work on a IPCop1.4.10 Installation
# The Error was not reproducable, its now working 
# on the same machine.
	    $count++;
####
# To test
#	    if (-T "$dir/$file"){
#	    print "ok";
#	    }else{
#	    print "<$file>";
#	    }
###	    
	   
       }
       closedir(BIN);
    }
    else
    {
       print "<br /><P> $Lang::tr{'copfilter show quarantine error'} \n";
       print $dir . "</P>\n";
    }
    
    return $count;
}

sub count_files_type
{
    my $ext = shift;

    my ($dir_spam1, $dir_spam2);

    $dir_spam1 = "/var/log/copfilter/default/opt/p3scan/quarantine";
    $dir_spam2 = "/var/log/copfilter/default/opt/proxsmtp/quarantine";
    return count_files($dir_spam1, $ext) + count_files($dir_spam2, $ext);
}

sub count_spams()
{
    return count_files_type("spam");
}

sub count_virus()
{
    return count_files_type("virus");
}

################################################################################
##   ACTIONs
################################################################################

######### Restart all services
if ( $copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter apply'} )
{
        &copfilter_start_log();
    print "<br />$Lang::tr{'copfilter restart1'} <br />";
    print "<br />$Lang::tr{'copfilter restart2'} <br />";
    print "<br /><b>$Lang::tr{'copfilter restart0'} p3scan..</b> <br />";
    system('/usr/local/bin/copfilter_restartp3scan');
    print "<br /><b>$Lang::tr{'copfilter restart0'} proxsmtpd..</b> <br />";
    system('/usr/local/bin/copfilter_restartproxsmtpd');
    print "<br /><b>$Lang::tr{'copfilter restart0'} spamd..</b> <br />";
    system('/usr/local/bin/copfilter_restartspamd');
    print "<br /><b>$Lang::tr{'copfilter restart0'} clamd..</b> <br />";
    system('/usr/local/bin/copfilter_restartclamd');
    if ( -e "${copfilter_swroot}/opt/avg/default/bin/avgscan") {
        print "<br /><b>$Lang::tr{'copfilter restart0'} avgscan..</b> <br />";
        system('/usr/local/bin/copfilter_restartavgscan');
    }
    if ( -e "${copfilter_swroot}/opt/f-prot/default/fpscand" ) {
        print "<br /><b>$Lang::tr{'copfilter restart0'} fpscand..</b> <br />";
        system('/usr/local/bin/copfilter_restartf-protd');
    }
    print "<br /><b>$Lang::tr{'copfilter restart0'} havp..</b> <br />";
    system('/usr/local/bin/copfilter_restarthavp');
    print "<br /><br /><b>$Lang::tr{'copfilter restart0'} privoxy..</b> <br />";
    system('/usr/local/bin/copfilter_restartprivoxy');
    print "<br /><br /><b>$Lang::tr{'copfilter restart0'} frox..</b> <br />";
    system('/usr/local/bin/copfilter_restartfrox');
    print "<br /><b>$Lang::tr{'copfilter restart0'} imspector..</b> <br />";
    system('/usr/local/bin/copfilter_restartimspector');
    print "<br /><b>$Lang::tr{'copfilter restart0'} monit..</b> <br />";
    system('/usr/local/bin/copfilter_restartmonit');
        &copfilter_stop_log();
}



######### Start p3scan
if (    $copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter start p3scan'} )
{
        &copfilter_start_log(); 
	    print "<br /><b>$Lang::tr{'copfilter start0'} p3scan..</b> <br />";
        system('/usr/local/bin/copfilter_startp3scan');
        &copfilter_stop_log(); 
}

######### Stop p3scan
if (    $copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter stop p3scan'} )
{
        &copfilter_start_log(); 
	    print "<br /><b>$Lang::tr{'copfilter stop0'} p3scan..</b> <br />";
        system('/usr/local/bin/copfilter_stopp3scan');
        &copfilter_stop_log(); 
}

######### Start proxsmtpd
if (    $copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter start proxsmtpd'} )
{
        &copfilter_start_log(); 
	    print "<br /><b>$Lang::tr{'copfilter start0'} proxsmtpd..</b> <br />";
        system('/usr/local/bin/copfilter_startproxsmtpd');
        &copfilter_stop_log(); 
}

######### Stop proxsmtpd
if (    $copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter stop proxsmtpd'} )
{
        &copfilter_start_log(); 
	    print "<br /><b>$Lang::tr{'copfilter stop0'} proxsmtpd..</b> <br />";
        system('/usr/local/bin/copfilter_stopproxsmtpd');
        &copfilter_stop_log(); 
}

######### Start clamd
if (    $copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter start clamd'} )
{
        &copfilter_start_log(); 
	    print "<br /><b>$Lang::tr{'copfilter start0'} clamd..</b> <br />";
        system('/usr/local/bin/copfilter_startclamd');
        print "<br /><b>$Lang::tr{'copfilter restart0'} havp..</b> <br />";
        system('/usr/local/bin/copfilter_restarthavp');
        print "<br /><b>$Lang::tr{'copfilter restart0'} privoxy..</b> <br />";
        system('/usr/local/bin/copfilter_restartprivoxy');
        &copfilter_stop_log(); 
}

######### Stop clamd
if (    $copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter stop clamd'} )
{
        &copfilter_start_log(); 
	    print "<br /><b>$Lang::tr{'copfilter stop0'} clamd..</b> <br />";
        system('/usr/local/bin/copfilter_stopclamd');
        print "<br /><b>$Lang::tr{'copfilter restart0'} havp..</b> <br />";
        system('/usr/local/bin/copfilter_restarthavp');
        print "<br /><b>$Lang::tr{'copfilter restart0'} privoxy..</b> <br />";
        system('/usr/local/bin/copfilter_restartprivoxy');
        &copfilter_stop_log(); 
}

######### Start avgscan
if (    $copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter start avgscan'} )
{
        &copfilter_start_log(); 
	    print "<br /><b>$Lang::tr{'copfilter start0'} avgscan..</b> <br />";
        system('/usr/local/bin/copfilter_startavgscan');
        print "<br /><b>$Lang::tr{'copfilter restart0'} havp..</b> <br />";
        system('/usr/local/bin/copfilter_restarthavp');
        print "<br /><b>$Lang::tr{'copfilter restart0'} privoxy..</b> <br />";
        system('/usr/local/bin/copfilter_restartprivoxy');
        &copfilter_stop_log(); 
}

######### Stop avgscan
if (    $copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter stop avgscan'} )
{
        &copfilter_start_log(); 
	    print "<br /><b>$Lang::tr{'copfilter stop0'} avgscan..</b> <br />";
        system('/usr/local/bin/copfilter_stopavgscan');
        print "<br /><b>$Lang::tr{'copfilter restart0'} havp..</b> <br />";
        system('/usr/local/bin/copfilter_restarthavp');
        print "<br /><b>$Lang::tr{'copfilter restart0'} privoxy..</b> <br />";
        system('/usr/local/bin/copfilter_restartprivoxy');
        &copfilter_stop_log(); 
}

######### Start f-protd
if (    $copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter start f-protd'} )
{
        &copfilter_start_log(); 
	    print "<br /><b>$Lang::tr{'copfilter start0'} fpscand..</b> <br />";
        system('/usr/local/bin/copfilter_startf-protd');
        print "<br /><b>$Lang::tr{'copfilter restart0'} havp..</b> <br />";
        system('/usr/local/bin/copfilter_restarthavp');
        print "<br /><b>$Lang::tr{'copfilter restart0'} privoxy..</b> <br />";
        system('/usr/local/bin/copfilter_restartprivoxy');
        &copfilter_stop_log(); 
}

######### Stop f-protd
if (    $copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter stop f-protd'} )
{
        &copfilter_start_log(); 
	    print "<br /><b>$Lang::tr{'copfilter stop0'} fpscand..</b> <br />";
        system('/usr/local/bin/copfilter_stopf-protd');
        print "<br /><b>$Lang::tr{'copfilter restart0'} havp..</b> <br />";
        system('/usr/local/bin/copfilter_restarthavp');
        print "<br /><b>$Lang::tr{'copfilter restart0'} privoxy..</b> <br />";
        system('/usr/local/bin/copfilter_restartprivoxy');
        &copfilter_stop_log(); 
}


######### Start privoxy
if (    $copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter start privoxy'} )
{
        &copfilter_start_log(); 
	    print "<br /><b>$Lang::tr{'copfilter start0'} privoxy..</b> <br />";
        system('/usr/local/bin/copfilter_startprivoxy');
        &copfilter_stop_log(); 
}

######### Stop privoxy
if (    $copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter stop privoxy'} )
{
        &copfilter_start_log(); 
	    print "<br /><b>$Lang::tr{'copfilter stop0'} privoxy..</b> <br />";
        system('/usr/local/bin/copfilter_stopprivoxy');
        &copfilter_stop_log(); 
}

######### Restart squid
if (    $copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter restart squid'} )
{
        &copfilter_start_log(); 
	    print "<br /><b>$Lang::tr{'copfilter start0'} squid..</b> <br />";
        system('/usr/local/bin/restartsquid');
        &copfilter_stop_log(); 
}

######### Start havp
if (    $copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter start havp'} )
{
        &copfilter_start_log(); 
	    print "<br /><b>$Lang::tr{'copfilter start0'} havp..</b> <br />";
        system('/usr/local/bin/copfilter_starthavp');
	    print "<br /><b>$Lang::tr{'copfilter start0'} privoxy..</b> <br />";
        system('/usr/local/bin/copfilter_startprivoxy');
        &copfilter_stop_log(); 
}

######### Stop havp
if (    $copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter stop havp'} )
{
        &copfilter_start_log(); 
	    print "<br /><b>$Lang::tr{'copfilter stop0'} privoxy..</b> <br />";
        system('/usr/local/bin/copfilter_stopprivoxy');
	    print "<br /><b>$Lang::tr{'copfilter stop0'} havp..</b> <br />";
        system('/usr/local/bin/copfilter_stophavp');
        &copfilter_stop_log(); 
}

######### Start spamd
if (    $copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter start spamd'} )
{
        &copfilter_start_log(); 
	    print "<br /><b>$Lang::tr{'copfilter start0'} spamd..</b> <br />";
        system('/usr/local/bin/copfilter_startspamd');
        &copfilter_stop_log(); 
}

######### Stop spamd
if (    $copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter stop spamd'} )
{
        &copfilter_start_log(); 
	    print "<br /><b>$Lang::tr{'copfilter stop0'} spamd..</b> <br />";
        system('/usr/local/bin/copfilter_stopspamd');
        &copfilter_stop_log(); 
}

######### Start frox
if (    $copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter start frox'} )
{
        &copfilter_start_log(); 
	    print "<br /><b>$Lang::tr{'copfilter start0'} frox..</b> <br />";
        system('/usr/local/bin/copfilter_startfrox');
        &copfilter_stop_log(); 
}

######### Stop frox
if (    $copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter stop frox'} )
{
        &copfilter_start_log(); 
	    print "<br /><b>$Lang::tr{'copfilter stop0'} frox..</b> <br />";
        system('/usr/local/bin/copfilter_stopfrox');
        &copfilter_stop_log(); 
}

######### Start imspector
if (    $copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter start imspector'} )
{
        system('cat /var/log/copfilter/default/etc/global_settings |sed -e "s/IM_SCAN=off/IM_SCAN=on/" >/tmp/imspector_tmp_file');
        system('mv /tmp/imspector_tmp_file /var/log/copfilter/default/etc/global_settings');
        &copfilter_start_log(); 
        print "<br /><b>$Lang::tr{'copfilter start0'} imspector..</b> <br />";
        system('/usr/local/bin/copfilter_startimspector');
        &copfilter_stop_log(); 
}

######### Stop imspector
if (    $copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter stop imspector'} )
{
        system('cat /var/log/copfilter/default/etc/global_settings |sed -e "s/IM_SCAN=on/IM_SCAN=off/" >/tmp/imspector_tmp_file');
        system('mv /tmp/imspector_tmp_file /var/log/copfilter/default/etc/global_settings');
        &copfilter_start_log(); 
	    print "<br /><b>$Lang::tr{'copfilter stop0'} imspector..</b> <br />";
        system('/usr/local/bin/copfilter_stopimspector');
        &copfilter_stop_log(); 
}

######### Start monit
if (    $copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter start monit'} )
{
        &copfilter_start_log(); 
	    print "<br /><b>$Lang::tr{'copfilter start0'} monit..</b> <br />";
        system('/usr/local/bin/copfilter_startmonit');
        &copfilter_stop_log(); 
}

######### Stop monit
if (    $copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter stop monit'} )
{
        &copfilter_start_log(); 
	    print "<br /><b>$Lang::tr{'copfilter stop0'} monit..</b> <br />";
        system('/usr/local/bin/copfilter_stopmonit');
        &copfilter_stop_log(); 
}

######### send quarantined email
if (    $copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter send q_mail'} )
{
        &copfilter_start_log();
        &writehashsorted("/tmp/env_send_q_mail.tmp", \%copfiltersettings);
        system ('/usr/local/bin/copfilter_send_q_mail');
        &copfilter_stop_log();
}


use File::stat;
use Time::localtime;

####################################
# Sort Spam Quarantine
# by copfilter forum user Taurus
# http://copfilter.endlich-mail.de/viewtopic.php?t=1307
#
if (    $copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter q_subject'} )
{  $sortorder = 1;
  $copfiltersettings{'ACTION'} = $Lang::tr{'copfilter show spam quarantine'};
}

if (    $copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter q_date'} )
{
  $sortorder = 2;
  $copfiltersettings{'ACTION'} = $Lang::tr{'copfilter show spam quarantine'};
}

if (    $copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter q_from'} )
{
  $sortorder = 3;
  $copfiltersettings{'ACTION'} = $Lang::tr{'copfilter show spam quarantine'};
}
if (    $copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter q_to'} )
{
  $sortorder = 4;
  $copfiltersettings{'ACTION'} = $Lang::tr{'copfilter show spam quarantine'};
}


#--------------------------------
######### Show spam quarantine

if (    $copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter show spam quarantine'} )
{
        &copfilter_start_log();

if (system ("ls /var/log/copfilter/default/opt/p3scan/quarantine >/dev/null 2>&1") eq 0 )
{

my ($dir, $file, $file2, $hit, $subject, $subject2, $sender, $sender2, $recipient, $recipient2, $date, $date2, @fileliste, @scoreliste, $index1, $nrofspams, $score, $help1, $date3, $sortorder1, $testvar, $testvar2);
#my ($dir, $file, $file2, $hit, $subject, $subject2, $sender, $sender2, $recipient, $recipient2, $date, $date2);
$dir = "/var/log/copfilter/default/opt/p3scan/quarantine";
print "<br />\n";
print "<b>$Lang::tr{'copfilter show spam quarantine'} - POP3 - $dir</b>\n";
print "<br><br>";
print "<form method='post' action='/cgi-bin/copfilter_status.cgi' enctype='multipart/form-data'>\n";
print "<table width='100%' cellpadding='2' cellspacing='0' color='#ffffff' border='1'>\n";
print "<TR>\n";
print "<td align='center'>del</td>\n";
print "<td align='center'>send</td>\n";
print "<td align='center'>add</td>\n";
#print "<td align='center'> $Lang::tr{'copfilter q_from'}      </td>\n";
print "<td align='center'> <input type='submit' name='ACTION' value='$Lang::tr{'copfilter q_from'}'   </td>\n";
#print "<td align='center'> $Lang::tr{'copfilter q_to'}       </td>\n";
print "<td align='center'> <input type='submit' name='ACTION' value='$Lang::tr{'copfilter q_to'}'   </td>\n";
#print "<td align='center'> $Lang::tr{'copfilter q_subject'}  </td>\n";
print "<td align='center'> <input type='submit' name='ACTION' value='$Lang::tr{'copfilter q_subject'}'  </td>\n";
#print "<td align='center'> $Lang::tr{'copfilter q_date'}     </td>\n";
print "<td align='center'> <input type='submit' name='ACTION' value='$Lang::tr{'copfilter q_date'}'     </td>\n";
print "<td align='center'> $Lang::tr{'copfilter q_filename'} </td>\n";
print "</TR>\n";

#######################
# Sort
$index1 = 0;
opendir(BIN, $dir) or die "Can't open $dir: $!";
foreach my $file (grep {/\.spam/} readdir BIN){
   $hit = 0;
   $subject = "";
   $subject2 = "";
   $sender = "";
   $recipient = "";
   $date = "";
   $score = "";
   $hit = 1 if -T "$dir/$file";
   if ($hit == 1) {
      open (EP,"$dir/$file");
      while (<EP>) {
         if (/^X-Spam-Status: Yes, score=/i) {
            $_ =~ s/X-Spam-Status: Yes, score=(.+)/$1/i;
	    $score=$_;
	    $score=~ s/_ req.*//i;
         }
        if (/^From: /i) {
            $_ =~ s/.+<(.+)>/$1/i;
            $sender = $_;
         }
#         if (/Envelope-To:/i) {
	 if (($recipient eq "") and (/^To: /i)) {
#            $_ =~ s/.+<(.+)>/$1/i;
#            $_ =~ s/$1/<to:(.+)>/i;

            $_ =~ s/.+<(.+)>/$1/i;
            $_ =~ s/to:(.+)/$1/i;
            $recipient = $_;
         }

	 if (($subject eq "") and (/^Subject: /i)) {
            $_ =~ s/subject:(.+)/$1/i;
            $subject = $_;
         }
         if (/Date:/i) {
            $_ =~ s/date:(.+)/$1/i;
            $date = $_;
         }

      }

#      printf("%02d.%02d.%04d-%02d:%02d:%02d\n",
#      $tm->mday, $tm->mon+1, $tm->year+1900,
#      $tm->hour, $tm->min, $tm->sec);

      my ($sec, $tm);
      $sec = stat("$dir/$file")->mtime;

      $sender2 =  substr($sender, 0, 30);
      $subject2 =  substr($subject, 14, 70);
#      $recipient2 =  substr($recipient, 0, 30);
      $recipient2 =  substr($recipient, 0, 30);
#      if ($recipient2 == "") {$recipient2="aaa";}
      $date2 =  substr($date, 6, 21);
      $file2 =  substr($file, 0, 13);

      $tm = localtime($sec);
      $date3=sprintf("%04d-%02d-%02d  %02d:%02d:%02d\n",
        $tm->year+1900, $tm->mon+1, $tm->mday,
        $tm->hour, $tm->min, $tm->sec);
   }
#   	 print "<";
#	 print $score;
#	 print "> \n";
    if ($recipient2 eq "") {$recipient2="                       ";}
####  
# Add leading Zeros, not nice - but works ;-)
  if (index($score,".") < 2){$score="0".$score;}
  if (index($score,".") < 3){$score="0".$score;}
# $sortorder bestimmt die Sortierung:
# 1 - sortiert nach Score (aufsteigend)
# 2 - sortiert nach Datum (aufsteigend)  
# 3 - sortiert nach From(aufsteigend)  
# 4 - sortiert nach To(aufsteigend)  
# 
#  $sortorder1=$sortorder & 127;
   $sortorder1=$sortorder;
# 
#
  if ($sortorder1 == 1) { $scoreliste[$index1]=$score."|".$file; }
  if ($sortorder1 == 2) { 
    $help1=substr($date3,0,18);
    $scoreliste[$index1]=$help1."|".$file; 
  }
  if ($sortorder1 == 3) { $scoreliste[$index1]=$sender2."|".$file; }
 if ($sortorder1 == 4) { 
   #
   $recipient2=~ s/<//;
   $recipient2=~ s/>//;
   $recipient2=~ s/\012//;
   $recipient2=~ s/,//;
   $recipient2=~ s/ //g;
   $scoreliste[$index1]=$recipient2."|".$file; 
 }
#     	 print "<";
#	 print $scoreliste[$index1];
#	 print "> \n";
  $index1++;
}
closedir(BIN);  
$nrofspams=$index1;
#print "-----------------------------------------";
$index1=0;
while ($index1 < $nrofspams){

 # print "$scoreliste[$index1]<TR>\n";
  $index1++;

}


@fileliste=sort{$a cmp $b} @scoreliste;
#if ($sortorder > 128){@fileliste=reverse(@fileliste);}

#print "---------------SORTED--------------------------";

$index1=0;
while ($index1 < $nrofspams){
 # print "+";    
 # print "$fileliste[$index1]<TR>\n";
  $index1++;
}


######################
#opendir(BIN, $dir) or die "Can't open $dir: $!";
$index1=0;
while ($index1 < $nrofspams){
   $help1=$fileliste[$index1];
   #
   # !!!
   #
   $file=substr($help1,index($help1,"|")+1,255);
   $hit = 0;
   $subject = "";
   $subject2 = "";
   $sender = "";
   $recipient = "";
   $date = "";
   $hit = 1 if -T "$dir/$file";

   if ($hit == 1) {
      open (EP,"$dir/$file");
      while (<EP>) {
         if (/^From: /i) {
            $_ =~ s/.+<(.+)>/$1/i;
            $sender = $_;
         }
#         if (/Envelope-To:/i) {
         if (/^To: /i) {
#            $_ =~ s/.+<(.+)>/$1/i;
#            $_ =~ s/$1/<to:(.+)>/i;

            $_ =~ s/.+<(.+)>/$1/i;
            $_ =~ s/to:(.+)/$1/i;
            $recipient = $_;
         }
	 # Bugfix, only the first ^Subject should be used
	 if (($subject eq "") and (/^Subject: /i)) {
              $_ =~ s/subject:(.+)/$1/i;
              $subject = $_;
         }
         if (/Date:/i) {
            $_ =~ s/date:(.+)/$1/i;
            $date = $_;
         }

      }

#      printf("%02d.%02d.%04d-%02d:%02d:%02d\n",
#      $tm->mday, $tm->mon+1, $tm->year+1900,
#      $tm->hour, $tm->min, $tm->sec);

      my ($sec, $tm);
      $sec = stat("$dir/$file")->mtime;

      $sender2 =  substr($sender, 0, 30);
      $subject2 =  substr($subject, 14, 70);
      $recipient2 =  substr($recipient, 0, 30);
      $date2 =  substr($date, 6, 21);
      $file2 =  substr($file, 0, 13);
      print "<TR>\n";
      print "<td class='base' align='center'><input type='checkbox' name='$dir/$file.delete' /></td>";
      print "<td class='base' align='center'><input type='checkbox' name='$dir/$file' /></td>";
      print "<td class='base' align='center'><input type='checkbox' name='$dir/$file.whitelist' /></td>";
      print "<td class='base' align='left'>$sender2</td>";
      print "<td class='base' align='left'>$recipient2</td>";
      print "<td class='base' align='left'>$subject2</td>";
      print "<td class='base' align='left'>";

      $tm = localtime($sec);
      printf("%04d-%02d-%02d  %02d:%02d:%02d\n",
      $tm->year+1900, $tm->mon+1, $tm->mday,
      $tm->hour, $tm->min, $tm->sec);
      print "</td>";
      print "<td class='base' align='left'><a href='/p3scan_quarantine/$file' target='_blank'>$file2</a></td>";
      print "</TR>";
   }
   $index1++;
}
#print "index1=$index1";
#closedir(BIN);
        print "</table>";

}
else
{
print "<br /><P> $Lang::tr{'copfilter show quarantine error'} \n";
print "/var/log/copfilter/default/opt/p3scan/quarantine</P>\n";
}

print "<br />\n";
print "<br />\n";
print "<br />\n";


if ( system ("ls /var/log/copfilter/default/opt/proxsmtp/quarantine >/dev/null 2>&1") eq 0 )
{
my ($dir, $file, $file2, $hit, $subject, $subject2, $sender, $sender2, $recipient, $recipient2, $date, $date2, @fileliste, @scoreliste, $index1, $nrofspams, $score, $help1, $date3, $sortorder1, $testvar, $testvar2);
#my ($dir, $file, $file2, $hit, $subject, $subject2, $sender, $sender2, $recipient, $recipient2, $date, $date2);
$dir = "/var/log/copfilter/default/opt/proxsmtp/quarantine";
print "<b>$Lang::tr{'copfilter show spam quarantine'} - SMTP - $dir</b>\n";
print "<br><br>";
print "<table width='100%' cellpadding='2' cellspacing='0' color='#ffffff' border='1'>\n";
print "<TR>\n";
print "<td align='center'>del</td>\n";
print "<td align='center'>send</td>\n";
print "<td align='center'>add</td>\n";
#print "<td align='center'> $Lang::tr{'copfilter q_from'}      </td>\n";
print "<td align='center'> <input type='submit' name='ACTION' value='$Lang::tr{'copfilter q_from'}'   </td>\n";
#print "<td align='center'> $Lang::tr{'copfilter q_to'}       </td>\n";
print "<td align='center'> <input type='submit' name='ACTION' value='$Lang::tr{'copfilter q_to'}'   </td>\n";
#print "<td align='center'> $Lang::tr{'copfilter q_subject'}  </td>\n";
print "<td align='center'> <input type='submit' name='ACTION' value='$Lang::tr{'copfilter q_subject'}'  </td>\n";
#print "<td align='center'> $Lang::tr{'copfilter q_date'}     </td>\n";
print "<td align='center'> <input type='submit' name='ACTION' value='$Lang::tr{'copfilter q_date'}'     </td>\n";
print "<td align='center'> $Lang::tr{'copfilter q_filename'} </td>\n";
print "</TR>\n";

#######################
# Sort
$index1 = 0;
opendir(BIN, $dir) or die "Can't open $dir: $!";
foreach my $file (grep {/\.spam/} readdir BIN){
   $hit = 0;
   $subject = "";
   $subject2 = "";
   $sender = "";
   $recipient = "";
   $date = "";
   $score = "";
   $hit = 1 if -T "$dir/$file";
   if ($hit == 1) {
      open (EP,"$dir/$file");
      while (<EP>) {
         if (/^X-Spam-Status: Yes, score=/i) {
            $_ =~ s/X-Spam-Status: Yes, score=(.+)/$1/i;
	    $score=$_;
	    $score=~ s/_ req.*//i;
         }
        if (/^From: /i) {
            $_ =~ s/.+<(.+)>/$1/i;
            $sender = $_;
         }
#         if (/Envelope-To:/i) {
	 if (($recipient eq "") and (/^To: /i)) {
#            $_ =~ s/.+<(.+)>/$1/i;
#            $_ =~ s/$1/<to:(.+)>/i;

            $_ =~ s/.+<(.+)>/$1/i;
            $_ =~ s/to:(.+)/$1/i;
            $recipient = $_;
         }

	 if (($subject eq "") and (/^Subject: /i)) {
            $_ =~ s/subject:(.+)/$1/i;
            $subject = $_;
         }
         if (/Date:/i) {
            $_ =~ s/date:(.+)/$1/i;
            $date = $_;
         }

      }

#      printf("%02d.%02d.%04d-%02d:%02d:%02d\n",
#      $tm->mday, $tm->mon+1, $tm->year+1900,
#      $tm->hour, $tm->min, $tm->sec);

      my ($sec, $tm);
      $sec = stat("$dir/$file")->mtime;

      $sender2 =  substr($sender, 0, 30);
      $subject2 =  substr($subject, 14, 70);
#      $recipient2 =  substr($recipient, 0, 30);
      $recipient2 =  substr($recipient, 0, 30);
#      if ($recipient2 == "") {$recipient2="aaa";}
      $date2 =  substr($date, 6, 21);
      $file2 =  substr($file, 0, 13);

      $tm = localtime($sec);
      $date3=sprintf("%04d-%02d-%02d  %02d:%02d:%02d\n",
        $tm->year+1900, $tm->mon+1, $tm->mday,
        $tm->hour, $tm->min, $tm->sec);
   }
#   	 print "<";
#	 print $score;
#	 print "> \n";
    if ($recipient2 eq "") {$recipient2="                       ";}
####  
# Add leading Zeros, not nice - but works ;-)
  if (index($score,".") < 2){$score="0".$score;}
  if (index($score,".") < 3){$score="0".$score;}
# $sortorder bestimmt die Sortierung:
# 1 - sortiert nach Score (aufsteigend)
# 2 - sortiert nach Datum (aufsteigend)  
# 3 - sortiert nach From (aufsteigend)  
# 4 - sortiert nach To (aufsteigend)  
# 
#  $sortorder1=$sortorder & 127;
   $sortorder1=$sortorder;
# 
#
  if ($sortorder1 == 1) { $scoreliste[$index1]=$score."|".$file; }
  if ($sortorder1 == 2) { 
    $help1=substr($date3,0,18);
    $scoreliste[$index1]=$help1."|".$file; 
  }
  if ($sortorder1 == 3) { $scoreliste[$index1]=$sender2."|".$file; }
 if ($sortorder1 == 4) { 
   #
   $recipient2=~ s/<//;
   $recipient2=~ s/>//;
   $recipient2=~ s/\012//;
   $recipient2=~ s/,//;
   $recipient2=~ s/ //g;
   $scoreliste[$index1]=$recipient2."|".$file; 
 }
#     	 print "<";
#	 print $scoreliste[$index1];
#	 print "> \n";
  $index1++;
}
closedir(BIN);  
$nrofspams=$index1;
#print "-----------------------------------------";
$index1=0;
while ($index1 < $nrofspams){

 # print "$scoreliste[$index1]<TR>\n";
  $index1++;

}


@fileliste=sort{$a cmp $b} @scoreliste;
#if ($sortorder > 128){@fileliste=reverse(@fileliste);}

#print "---------------SORTED--------------------------";


######################
#opendir(BIN, $dir) or die "Can't open $dir: $!";
$index1=0;
while ($index1 < $nrofspams){
   $help1=$fileliste[$index1];
   #
   # !!!
   #
   $file=substr($help1,index($help1,"|")+1,255);
   $hit = 0;
   $subject = "";
   $subject2 = "";
   $sender = "";
   $recipient = "";
   $date = "";
   $hit = 1 if -T "$dir/$file";
       if ($hit == 1) {
          open (EP,"$dir/$file");
          while (<EP>) {
         if (/^From: /i) {
            $_ =~ s/.+<(.+)>/$1/i;

#            $_ =~ s/$1/.+<from:(.+)>/i;
#            $_ =~ s/.*(([A-Z0-9]+[._]?){1,}[A-Z0-9]+\@(([A-Z0-9]+[-]?){1,}[A-Z0-9]+\.){1,}[A-Z]{2,4}).*/$1/i;
#            $_ =~ s/.*(@).*/$1/i;
#            $_ =~ s/.*(\b\[A-Z0-9._%-\]++@\[A-Z0-9._%-\]+\.\[A-Z\]\{2,4\}\b).*/$1/i;
#            $_ =~ s/[ .><]*([0-9a-zA-Z-.]+\@[-.\w]+\.\w{2,3}\W)[ <>.]*/$1/i;
##             $_ = ~ /^From:\s([a-zA-Z0-9._-]+@[a-zA-Z0-9._-]+\.[a-zA-Z0-9._-]+)$/

            $sender = $_;
         }
#         if (/Envelope-To:/i) {
         if (/^To: /i) {
#            $_ =~ s/.+<(.+)>/$1/i;
#            $_ =~ s/$1/<to:(.+)>/i;

            $_ =~ s/.+<(.+)>/$1/i;
            $_ =~ s/to:(.+)/$1/i;
            $recipient = $_;
         }
         if (/^Subject: /i) {
            $_ =~ s/subject:(.+)/$1/i;
            $subject = $_;
         }
         if (/Date:/i) {
            $_ =~ s/date:(.+)/$1/i;
            $date = $_;
         }


          }

          my ($sec, $tm);
          $sec = stat("$dir/$file")->mtime;

          $sender2 =  substr($sender, 0, 30);
          $subject2 =  substr($subject, 14, 70);
          $recipient2 =  substr($recipient, 0, 30);
          $date2 =  substr($date, 6, 21);
          $file2 =  substr($file, 0, 16);
          print "<TR>\n";
          print "<td class='base' align='center'><input type='checkbox' name='$dir/$file.delete' /></td>";
          print "<td class='base' align='center'><input type='checkbox' name='$dir/$file' /></td>";
          print "<td class='base' align='center'><input type='checkbox' name='$dir/$file.whitelist' /></td>";
          print "<td class='base' align='left'>$sender2</td>";
          print "<td class='base' align='left'>$recipient2</td>";
          print "<td class='base' align='left'>$subject2</td>";
          print "<td class='base' align='left'>";

          $tm = localtime($sec);
      printf("%04d-%02d-%02d  %02d:%02d:%02d\n",
          $tm->year+1900, $tm->mon+1, $tm->mday,
          $tm->hour, $tm->min, $tm->sec);
          print "</td>";
          print "<td class='base' align='left'><a href='/proxsmtp_quarantine/$file' target='_blank'>$file2</a></td>";
          print "</TR>";

       }
  $index1++;
    }
    closedir(BIN);
    print <<END
    </table><br /><br />

    <table border='0'>
    <tr><td> del ... </td><td>&nbsp; $Lang::tr{'copfilter send q_mail6'}</td></tr>
    <tr><td> send ... </td><td>&nbsp; $Lang::tr{'copfilter send q_mail4'}</td></tr>
    <tr><td> add &nbsp;... </td><td>&nbsp; $Lang::tr{'copfilter send q_mail5'}</td></tr>
    </table><br /><br />

    <table border='0'>
    <tr><td>
           <input type='checkbox' name='DELETE_ALL_SPAM' /> $Lang::tr{'copfilter send q_mail2'}
       </td>
    </tr>

    <tr><td>
            &nbsp;
       </td>
    </tr>

    <tr><td>
           <input type='submit' name='ACTION' value='$Lang::tr{'copfilter send q_mail'}' />
       </td>

       <td width=15 >
            &nbsp;
       </td>
    </tr>
    </table>
    </form>

END
;

}
else
{
print "<br /><P>$Lang::tr{'copfilter show quarantine error'} \n";
print "/var/log/copfilter/default/opt/proxsmtp/quarantine</P>\n";
}
        &copfilter_stop_log();
}











#--------------------------------



####################################
# Sort Virus Quarantine
# by copfilter forum user Taurus
# http://copfilter.endlich-mail.de/viewtopic.php?t=1307
#
if (    $copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter v_subject'} )
{
	$sortorder = 1;
	$copfiltersettings{'ACTION'} = $Lang::tr{'copfilter show virus quarantine'};
}
if (    $copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter v_date'} )
{
  $sortorder = 2;
  $copfiltersettings{'ACTION'} = $Lang::tr{'copfilter show virus quarantine'};
}

if (    $copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter v_from'} )
{
  $sortorder = 3;
  $copfiltersettings{'ACTION'} = $Lang::tr{'copfilter show virus quarantine'};
}
if (    $copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter v_to'} )
{
  $sortorder = 4;
  $copfiltersettings{'ACTION'} = $Lang::tr{'copfilter show virus quarantine'};
}
if (    $copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter v_virusname'} )
{
  $sortorder = 5;
  $copfiltersettings{'ACTION'} = $Lang::tr{'copfilter show virus quarantine'};
}




######### Show virus quarantine

if (    $copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter show virus quarantine'} )
{
        &copfilter_start_log();

if (system ("ls /var/log/copfilter/default/opt/p3scan/quarantine >/dev/null 2>&1") eq 0 )
{
my ($dir, $file, $file2, $hit, $subject, $subject2, $sender, $sender2, $recipient, $recipient2, $date, $date2, @fileliste, @scoreliste, $index1, $nrofspams, $score, $help1, $date3, $sortorder1, $testvar, $testvar2, $virusname, $virusfilename);
#my ($dir, $file, $file2, $hit, $subject, $subject2, $sender, $sender2, $recipient, $recipient2, $date, $date2);
$dir = "/var/log/copfilter/default/opt/p3scan/quarantine";
print "<br />\n";
print "<b>$Lang::tr{'copfilter show virus quarantine'} - POP3 - $dir</b>\n";
print "<br><br>";
print "<form method='post' action='/cgi-bin/copfilter_status.cgi' enctype='multipart/form-data'>\n";
print "<table width='100%' cellpadding='2' cellspacing='0' color='#ffffff' border='1'>\n";
print "<TR>\n";
print "<td align='center'>del</td>\n";
print "<td align='center'>send</td>\n";
#print "<td align='center'> $Lang::tr{'copfilter q_from'}      </td>\n";
print "<td align='center'> <input type='submit' name='ACTION' value='$Lang::tr{'copfilter v_from'}'   </td>\n";
#print "<td align='center'> $Lang::tr{'copfilter q_to'}       </td>\n";
print "<td align='center'> <input type='submit' name='ACTION' value='$Lang::tr{'copfilter v_to'}'   </td>\n";
#print "<td align='center'> $Lang::tr{'copfilter q_subject'}  </td>\n";
print "<td align='center'> <input type='submit' name='ACTION' value='$Lang::tr{'copfilter v_subject'}'   </td>\n";
#print "<td align='center'> $Lang::tr{'copfilter v_virusname'}     </td>\n";
print "<td align='center'> <input type='submit' name='ACTION' value='$Lang::tr{'copfilter v_virusname'}'   </td>\n";
#print "<td align='center'> $Lang::tr{'copfilter q_date'}     </td>\n";
print "<td align='center'> <input type='submit' name='ACTION' value='$Lang::tr{'copfilter v_date'}'   </td>\n";
print "<td align='center'> $Lang::tr{'copfilter v_filename'} </td>\n";
#print "<td align='center'> <input type='submit' name='ACTION' value='$Lang::tr{'copfilter v_filename'}'   </td>\n";
print "</TR>\n";

#######################
# Sort
$index1 = 0;
opendir(BIN, $dir) or die "Can't open $dir: $!";
foreach my $file (grep {/\.virus$/} readdir BIN){
   $hit = 0;
   $subject = "";
   $subject2 = "";
   $sender = "";
   $recipient = "";
   $date = "";
   $hit = 1 if -T "$dir/$file";
   if ($hit == 1) {
      open (EP,"$dir/$file");
      while (<EP>) {
        if (/^From: /i) {
            $_ =~ s/.+<(.+)>/$1/i;
            $sender = $_;
         }
#         if (/Envelope-To:/i) {
	 if (($recipient eq "") and (/^To: /i)) {
#            $_ =~ s/.+<(.+)>/$1/i;
#            $_ =~ s/$1/<to:(.+)>/i;

            $_ =~ s/.+<(.+)>/$1/i;
            $_ =~ s/to:(.+)/$1/i;
            $recipient = $_;
         }

	 if (($subject eq "") and (/^Subject: /i)) {
            $_ =~ s/subject:(.+)/$1/i;
            $subject = $_;
         }
         if (/Date:/i) {
            $_ =~ s/date:(.+)/$1/i;
            $date = $_;
         }

      }

#      printf("%02d.%02d.%04d-%02d:%02d:%02d\n",
#      $tm->mday, $tm->mon+1, $tm->year+1900,
#      $tm->hour, $tm->min, $tm->sec);

      my ($sec, $tm);
      $sec = stat("$dir/$file")->mtime;

      $sender2 =  substr($sender, 0, 30);
      $subject2 =  substr($subject, 0, 70);
#      $recipient2 =  substr($recipient, 0, 30);
      $recipient2 =  substr($recipient, 0, 30);
#      if ($recipient2 == "") {$recipient2="aaa";}
      $date2 =  substr($date, 6, 21);
      $file2 =  substr($file, 0, 13);

      $tm = localtime($sec);
      $date3=sprintf("%04d-%02d-%02d  %02d:%02d:%02d\n",
        $tm->year+1900, $tm->mon+1, $tm->mday,
        $tm->hour, $tm->min, $tm->sec);
   }
#   	 print "<";
#	 print $score;
#	 print "> \n";
    if ($recipient2 eq "") {$recipient2="                       ";}
####  
# Add leading Zeros, not nice - but works ;-)
#  if (index($score,".") < 2){$score="0".$score;}
#  if (index($score,".") < 3){$score="0".$score;}
# $sortorder bestimmt die Sortierung:
# 1 - sortiert nach Subject (aufsteigend)
# 2 - sortiert nach Datum (aufsteigend)  
# 3 - sortiert nach From(aufsteigend)  
# 4 - sortiert nach To(aufsteigend)  
# 5 - sortiert nach Virusname
#  $sortorder1=$sortorder & 127;
   $sortorder1=$sortorder;
# 
#
      $virusfilename = "$dir/$file\.name";        # Name the file

      open(VIRUSNAME, $virusfilename);        # Open the file
      $virusname = <VIRUSNAME>;      # Read it into an array
      close(VIRUSNAME);          # Close the file


  if ($sortorder1 == 1) { $scoreliste[$index1]=$subject."|".$file; }
  if ($sortorder1 == 2) { 
    $help1=substr($date3,0,18);
    $scoreliste[$index1]=$help1."|".$file; 
  }
  if ($sortorder1 == 3) { $scoreliste[$index1]=$sender2."|".$file; }
 if ($sortorder1 == 4) { 
   #
   $recipient2=~ s/<//;
   $recipient2=~ s/>//;
   $recipient2=~ s/\012//;
   $recipient2=~ s/,//;
   $recipient2=~ s/ //g;
   $scoreliste[$index1]=$recipient2."|".$file; 
 }
 if ($sortorder1 == 5) { $scoreliste[$index1]=$virusname."|".$file; }
#     	 print "<";
#	 print $scoreliste[$index1];
#	 print "> \n";
  $index1++;
}
closedir(BIN);  
$nrofspams=$index1;
#print "-----------------------------------------";
$index1=0;
while ($index1 < $nrofspams){

 # print "$scoreliste[$index1]<TR>\n";
  $index1++;

}


@fileliste=sort{$a cmp $b} @scoreliste;
#if ($sortorder > 128){@fileliste=reverse(@fileliste);}

#print "---------------SORTED--------------------------";


#####################################################
#opendir(BIN, $dir) or die "Can't open $dir: $!";
#while( defined ($file = readdir(BIN))) {
$index1=0;
while ($index1 < $nrofspams){
   $help1=$fileliste[$index1];
   #
   # !!!
   #
   $file=substr($help1,index($help1,"|")+1,255);
   $hit = 0;
   $subject = "";
   $subject2 = "";
   $sender = "";
   $recipient = "";
   $date = "";
   $hit = 1 if -T "$dir/$file";
#!!!   $hit = 1 if -T "$dir/$file";
   $hit = 1;
   if ($hit == 1) {
      open (EP,"<$dir/$file") or print "open failed";
      while (<EP>) {
         if (/^From: /i) {
            $_ =~ s/.+<(.+)>/$1/i;

#            $_ =~ s/$1/.+<from:(.+)>/i;
#            $_ =~ s/.*(([A-Z0-9]+[._]?){1,}[A-Z0-9]+\@(([A-Z0-9]+[-]?){1,}[A-Z0-9]+\.){1,}[A-Z]{2,4}).*/$1/i;
#            $_ =~ s/.*(@).*/$1/i;
#            $_ =~ s/.*(\b\[A-Z0-9._%-\]++@\[A-Z0-9._%-\]+\.\[A-Z\]\{2,4\}\b).*/$1/i;
#            $_ =~ s/[ .><]*([0-9a-zA-Z-.]+\@[-.\w]+\.\w{2,3}\W)[ <>.]*/$1/i;
##             $_ = ~ /^From:\s([a-zA-Z0-9._-]+@[a-zA-Z0-9._-]+\.[a-zA-Z0-9._-]+)$/

            $sender = $_;
         }
#         if (/Envelope-To:/i) {
         if (/^To: /i) {
#            $_ =~ s/.+<(.+)>/$1/i;
#            $_ =~ s/$1/<to:(.+)>/i;

            $_ =~ s/.+<(.+)>/$1/i;
            $_ =~ s/to:(.+)/$1/i;
            $recipient = $_;
         }
         if (/^Subject: /i) {
            $_ =~ s/subject:(.+)/$1/i;
            $subject = $_;
         }
         if (/Date:/i) {
            $_ =~ s/date:(.+)/$1/i;
            $date = $_;
         }

      }

      my ($sec, $tm);
      $sec = stat("$dir/$file")->mtime;

      $sender2 =  substr($sender, 0, 30);
      $subject2 =  substr($subject, 0, 70);
      $recipient2 =  substr($recipient, 0, 30);
      $date2 =  substr($date, 6, 21);
      $file2 =  substr($file, 0, 13);
      print "<TR>\n";
      print "<td class='base' align='center'><input type='checkbox' name='$dir/$file.delete' /></td>";
      print "<td class='base' align='center'><input type='checkbox' name='$dir/$file' /></td>";
      print "<td class='base' align='left'>$sender2</td>";
      print "<td class='base' align='left'>$recipient2</td>";
      print "<td class='base' align='left'>$subject2</td>";
      print "<td class='base' align='left'>";

      $virusfilename = "$dir/$file\.name";        # Name the file

     open(VIRUSNAME, $virusfilename);        # Open the file
      $virusname = <VIRUSNAME>;      # Read it into an array
      close(VIRUSNAME);          # Close the file
      print $virusname;         # Print the array

      print "</td>";
      print "<td class='base' align='left'>";

      $tm = localtime($sec);
      printf("%04d-%02d-%02d  %02d:%02d:%02d\n",
      $tm->year+1900, $tm->mon+1, $tm->mday,
      $tm->hour, $tm->min, $tm->sec);
      print "</td>";
      print "<td class='base' align='left'><a href='/p3scan_quarantine/$file' target='_blank'>$file2</a></td>";
      print "</TR>";

   }
   $index1++;
}
closedir(BIN);
        print "</table>";

}
else
{
print "<br /><P> $Lang::tr{'copfilter show quarantine error'} \n";
print "/var/log/copfilter/default/opt/p3scan/quarantine</P>\n";
}

print "<br />\n";
print "<br />\n";
print "<br />\n";


if ( system ("ls /var/log/copfilter/default/opt/proxsmtp/quarantine >/dev/null 2>&1") eq 0 )
{
my ($dir, $file, $file2, $hit, $subject, $subject2, $sender, $sender2, $recipient, $recipient2, $date, $date2, @fileliste, @scoreliste, $index1, $nrofspams, $score, $help1, $date3, $sortorder1, $testvar, $testvar2, $virusname, $virusfilename);
#my ($dir, $file, $file2, $hit, $subject, $subject2, $sender, $sender2, $recipient, $recipient2, $date, $date2);
$dir = "/var/log/copfilter/default/opt/proxsmtp/quarantine";
print "<b>$Lang::tr{'copfilter show virus quarantine'} - SMTP - $dir</b>\n";
print "<br><br>";
print "<table width='100%' cellpadding='2' cellspacing='0' color='#ffffff' border='1'>\n";
print "<TR>\n";
print "<td align='center'>del</td>\n";
print "<td align='center'>send</td>\n";
#print "<td align='center'> $Lang::tr{'copfilter q_from'}      </td>\n";
print "<td align='center'> <input type='submit' name='ACTION' value='$Lang::tr{'copfilter v_from'}'   </td>\n";
#print "<td align='center'> $Lang::tr{'copfilter q_to'}       </td>\n";
print "<td align='center'> <input type='submit' name='ACTION' value='$Lang::tr{'copfilter v_to'}'   </td>\n";
#print "<td align='center'> $Lang::tr{'copfilter q_subject'}  </td>\n";
print "<td align='center'> <input type='submit' name='ACTION' value='$Lang::tr{'copfilter v_subject'}'   </td>\n";
#print "<td align='center'> $Lang::tr{'copfilter v_virusname'}     </td>\n";
print "<td align='center'> <input type='submit' name='ACTION' value='$Lang::tr{'copfilter v_virusname'}'   </td>\n";
#print "<td align='center'> $Lang::tr{'copfilter q_date'}     </td>\n";
print "<td align='center'> <input type='submit' name='ACTION' value='$Lang::tr{'copfilter v_date'}'   </td>\n";
print "<td align='center'> $Lang::tr{'copfilter v_filename'} </td>\n";
#print "<td align='center'> <input type='submit' name='ACTION' value='$Lang::tr{'copfilter v_filename'}'   </td>\n";
print "</TR>\n";

#######################
# Sort
$index1 = 0;
opendir(BIN, $dir) or die "Can't open $dir: $!";
foreach my $file (grep {/\.virus$/} readdir BIN){
   $hit = 0;
   $subject = "";
   $subject2 = "";
   $sender = "";
   $recipient = "";
   $date = "";
   $hit = 1 if -T "$dir/$file";
   if ($hit == 1) {
      open (EP,"$dir/$file");
      while (<EP>) {
        if (/^From: /i) {
            $_ =~ s/.+<(.+)>/$1/i;
            $sender = $_;
         }
#         if (/Envelope-To:/i) {
	 if (($recipient eq "") and (/^To: /i)) {
#            $_ =~ s/.+<(.+)>/$1/i;
#            $_ =~ s/$1/<to:(.+)>/i;

            $_ =~ s/.+<(.+)>/$1/i;
            $_ =~ s/to:(.+)/$1/i;
            $recipient = $_;
         }

	 if (($subject eq "") and (/^Subject: /i)) {
            $_ =~ s/subject:(.+)/$1/i;
            $subject = $_;
         }
         if (/Date:/i) {
            $_ =~ s/date:(.+)/$1/i;
            $date = $_;
         }

      }

#      printf("%02d.%02d.%04d-%02d:%02d:%02d\n",
#      $tm->mday, $tm->mon+1, $tm->year+1900,
#      $tm->hour, $tm->min, $tm->sec);

      my ($sec, $tm);
      $sec = stat("$dir/$file")->mtime;

      $sender2 =  substr($sender, 0, 30);
      $subject2 =  substr($subject, 0, 70);
#      $recipient2 =  substr($recipient, 0, 30);
      $recipient2 =  substr($recipient, 0, 30);
#      if ($recipient2 == "") {$recipient2="aaa";}
      $date2 =  substr($date, 6, 21);
      $file2 =  substr($file, 0, 13);

      $tm = localtime($sec);
      $date3=sprintf("%04d-%02d-%02d  %02d:%02d:%02d\n",
        $tm->year+1900, $tm->mon+1, $tm->mday,
        $tm->hour, $tm->min, $tm->sec);
   }
#   	 print "<";
#	 print $score;
#	 print "> \n";
    if ($recipient2 eq "") {$recipient2="                       ";}
####  
# Add leading Zeros, not nice - but works ;-)
#  if (index($score,".") < 2){$score="0".$score;}
#  if (index($score,".") < 3){$score="0".$score;}
# $sortorder bestimmt die Sortierung:
# 1 - sortiert nach Subject (aufsteigend)
# 2 - sortiert nach Datum (aufsteigend)  
# 3 - sortiert nach From(aufsteigend)  
# 4 - sortiert nach To(aufsteigend)  
# 5 - sortiert nach Virusname
# 
#  $sortorder1=$sortorder & 127;
   $sortorder1=$sortorder;
# 
#
      $virusfilename = "$dir/$file\.name";        # Name the file

      open(VIRUSNAME, $virusfilename);        # Open the file
      $virusname = <VIRUSNAME>;      # Read it into an array
      close(VIRUSNAME);          # Close the file

  if ($sortorder1 == 1) { $scoreliste[$index1]=$subject."|".$file; }
  if ($sortorder1 == 2) { 
    $help1=substr($date3,0,18);
    $scoreliste[$index1]=$help1."|".$file; 
  }
  if ($sortorder1 == 3) { $scoreliste[$index1]=$sender2."|".$file; }
 if ($sortorder1 == 4) { 
   #
   $recipient2=~ s/<//;
   $recipient2=~ s/>//;
   $recipient2=~ s/\012//;
   $recipient2=~ s/,//;
   $recipient2=~ s/ //g;
   $scoreliste[$index1]=$recipient2."|".$file; 
 }
  if ($sortorder1 == 5) { $scoreliste[$index1]=$virusname."|".$file; }
#     	 print "<";
#	 print $scoreliste[$index1];
#	 print "> \n";
  $index1++;
}
closedir(BIN);  
$nrofspams=$index1;
#print "-----------------------------------------";
$index1=0;
while ($index1 < $nrofspams){

 # print "$scoreliste[$index1]<TR>\n";
  $index1++;

}


@fileliste=sort{$a cmp $b} @scoreliste;
#if ($sortorder > 128){@fileliste=reverse(@fileliste);}

#print "---------------SORTED--------------------------";


#####################################################
#opendir(BIN, $dir) or die "Can't open $dir: $!";
#while( defined ($file = readdir(BIN))) {
$index1=0;
while ($index1 < $nrofspams){
   $help1=$fileliste[$index1];
   #
   # !!!
   #
   $file=substr($help1,index($help1,"|")+1,255);
   $hit = 0;
   $subject = "";
   $subject2 = "";
   $sender = "";
   $recipient = "";
   $date = "";
   $hit = 1 if -T "$dir/$file";
#!!!   $hit = 1 if -T "$dir/$file";
       if ($hit == 1) {
          open (EP,"$dir/$file");
          while (<EP>) {
         if (/^From: /i) {
            $_ =~ s/.+<(.+)>/$1/i;

#            $_ =~ s/$1/.+<from:(.+)>/i;
#            $_ =~ s/.*(([A-Z0-9]+[._]?){1,}[A-Z0-9]+\@(([A-Z0-9]+[-]?){1,}[A-Z0-9]+\.){1,}[A-Z]{2,4}).*/$1/i;
#            $_ =~ s/.*(@).*/$1/i;
#            $_ =~ s/.*(\b\[A-Z0-9._%-\]++@\[A-Z0-9._%-\]+\.\[A-Z\]\{2,4\}\b).*/$1/i;
#            $_ =~ s/[ .><]*([0-9a-zA-Z-.]+\@[-.\w]+\.\w{2,3}\W)[ <>.]*/$1/i;
##             $_ = ~ /^From:\s([a-zA-Z0-9._-]+@[a-zA-Z0-9._-]+\.[a-zA-Z0-9._-]+)$/

            $sender = $_;
         }
#         if (/Envelope-To:/i) {
         if (/^To: /i) {
#            $_ =~ s/.+<(.+)>/$1/i;
#            $_ =~ s/$1/<to:(.+)>/i;

            $_ =~ s/.+<(.+)>/$1/i;
            $_ =~ s/to:(.+)/$1/i;
            $recipient = $_;
         }
         if (/^Subject: /i) {
            $_ =~ s/subject:(.+)/$1/i;
            $subject = $_;
         }
         if (/Date:/i) {
            $_ =~ s/date:(.+)/$1/i;
            $date = $_;
         }


          }

      my ($sec, $tm);
      $sec = stat("$dir/$file")->mtime;

      $sender2 =  substr($sender, 0, 30);
      $subject2 =  substr($subject, 0, 70);
      $recipient2 =  substr($recipient, 0, 30);
      $date2 =  substr($date, 6, 21);
      $file2 =  substr($file, 0, 16);
      print "<TR>\n";
      print "<td class='base' align='center'><input type='checkbox' name='$dir/$file.delete' /></td>";
      print "<td class='base' align='center'><input type='checkbox' name='$dir/$file' /></td>";
      print "<td class='base' align='left'>$sender2</td>";
      print "<td class='base' align='left'>$recipient2</td>";
      print "<td class='base' align='left'>$subject2</td>";
      print "<td class='base' align='left'>";

      $virusfilename = "$dir/$file\.name";        # Name the file

      open(VIRUSNAME, $virusfilename);        # Open the file
      $virusname = <VIRUSNAME>;      # Read it into an array
      close(VIRUSNAME);          # Close the file
      print $virusname;         # Print the array

      print "</td>";
      print "<td class='base' align='left'>";

      $tm = localtime($sec);
      printf("%04d-%02d-%02d  %02d:%02d:%02d\n",
      $tm->year+1900, $tm->mon+1, $tm->mday,
      $tm->hour, $tm->min, $tm->sec);
      print "</td>";
      print "<td class='base' align='left'><a href='/proxsmtp_quarantine/$file' target='_blank'>$file2</a></td>";
      print "</TR>";

       }
   $index1++;
    }
    closedir(BIN);

    print <<END
    </table><br /><br />

    <table border='0'>
    <tr><td> del ... </td><td>&nbsp; $Lang::tr{'copfilter send q_mail6'}</td></tr>
    <tr><td> send ... </td><td>&nbsp; $Lang::tr{'copfilter send q_mail4'}</td></tr>
    </table><br /><br />

    <table border='0'>
    <tr><td>
           <input type='checkbox' name='DELETE_ALL_VIRUS' /> $Lang::tr{'copfilter send q_mail2'}
       </td>
    </tr>

    <tr><td>
            &nbsp;
       </td>
    </tr>

    <tr><td>
           <input type='submit' name='ACTION' value='$Lang::tr{'copfilter send q_mail'}' />
       </td>

       <td width=15 >
            &nbsp;
       </td>
    </tr>
    </table>
    </form>

END
;


}
else
{
print "<br /><P>$Lang::tr{'copfilter show quarantine error'} \n";
print "/var/log/copfilter/default/opt/proxsmtp/quarantine</P>\n";
}
        &copfilter_stop_log();
}









######### Save settings

if ($copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter save'})
{ 

################################################################################
##   Checking input values
################################################################################

	if  ($copfiltersettings{'POP3_SCAN_GREEN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_SCAN_ORANGE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_SCAN_BLUE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_VIRUS_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_SPAM_QUARANTINE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_VIRUS_QUARANTINE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_ATTACHMENT_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_SPAM_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_MAIL_REWRITE_SUBJECT'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_MAIL_ADD_HEADER'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_MAIL_ADD_BODY'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_VIRUS_ADMINNOTIF'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SCAN_GREEN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SCAN_ORANGE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SCAN_BLUE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SCAN_RED'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_VIRUS_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SPAM_QUARANTINE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_VIRUS_QUARANTINE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SPAM_QUARANTINE_NOTIFY_USER'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_VIRUS_NOTIFY_USER'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'SMTP_VIRUS_SCAN_BOUNCE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_VIRUS_SCAN_DISCARD'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_ATTACHMENT_SCAN'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'SMTP_ATTACHMENT_SCAN_BOUNCE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_ATTACHMENT_SCAN_DISCARD'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SPAM_SCAN'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'SMTP_SPAM_SCAN_BOUNCE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SPAM_SCAN_DISCARD'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_AUTH_ENABLE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'IMAP_ENABLE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'IMAP_DEBUG'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'IMAP_DAILY'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_MAIL_REWRITE_SUBJECT'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_MAIL_ADD_HEADER'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_MAIL_ADD_BODY'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_VIRUS_ADMINNOTIF'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SPAM_SCAN_SPEEDUP'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'PRIVOXY_ENABLE'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'HTTP_SCAN_GREEN'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'HTTP_SCAN_ORANGE'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'HTTP_SCAN_BLUE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'HTTP_VIRUS_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'MONIT_ENABLE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'FTP_SCAN_GREEN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'FTP_SCAN_ORANGE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'FTP_SCAN_BLUE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'CLAMD_ENABLE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'FPROT_ENABLE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'IM_SCAN'} !~ /^(on|off)$/ ) 
        {
		$errormessage = $Lang::tr{'copfilter invalid input'};
		goto ERROR;
	} 


ERROR:
	if ($errormessage) {
		$copfiltersettings{'VALID'} = 'no'; }
	else {
              	$copfiltersettings{'VALID'} = 'yes'; }




################################################################################
##   purge enable and update files
################################################################################



	if ($copfiltersettings{'VALID'} eq 'yes')
	{

         # if setting were valid, write settings and reconfigure
         &writehashsorted("${copfilter_swroot}/etc/global_settings", \%copfiltersettings);

     }


$copfiltersettings{'ACTION'} = '';

}






################################################################################
##  Website - Information
################################################################################


#for testing purposes only
#&General::writehash("/tmp/settings", \%copfiltersettings);

if ($copfiltersettings{'ACTION'} eq '')
{

&Header::openbigbox('100%', 'left', '', $errormessage);


#if ($errormessage) {
#    &Header::openbox('100%', 'left', $Lang::tr{'copfilter error messages'});
#    print "<class name='base'><font color='${Header::colourred}'>$errormessage\n</font>";
#    print "&nbsp;</class>\n";
#    &Header::closebox();
#}

if ($errormessage) {
    #&Header::openbox('100%', 'left', $Lang::tr{'copfilter error messages'});
    &Header::openbox('100%', 'left', "$Lang::tr{'copfilter error messages'}:", 'error');
    #print "<font class='base'><font color='${Header::colourred}'>$errormessage&nbsp;</font>\n";
    print "<font class='base'>$errormessage&nbsp;</font>\n";
    &Header::closebox();
}

my $nbr_spams = count_spams();
my $nbr_virus = count_virus();
my $quarantinev_but;
my $quarantines_but;

if (not($nbr_virus)) {
    $quarantinev_but="quarantine.png"; }
else {
    $quarantinev_but="quarantine-rot.png";
}

if (not($nbr_spams)) {
    $quarantines_but="quarantine.png"; }
else {
    $quarantines_but="quarantine-rot.png";
}

&Header::openbox('100%', 'left', "<b><font size='3'><a href='http://www.copfilter.org' target='_blank'>Copfilter</a></font></b>");
print <<END

<table width='100%' border='1' cellpadding='2'>

<tr>
        <td align='center' width='20%'><b> $Lang::tr{'copfilter versiondes'}: </b>$copfiltersettings{'VERSION'}</td>

        <td align='center' width='80%'>
                <b>$Lang::tr{'copfilter docu'}:</b>
        <a href='/copfilterdoc/${language}/README'>README</a>&nbsp;
        <a href='/copfilterdoc/${language}/CHANGELOG'>CHANGELOG</a>&nbsp;
        <a href='/copfilterdoc/${language}/CREDITS'>CREDITS</a>&nbsp;
        <a href='/copfilterdoc/${language}/BUGS'>BUGS</a>&nbsp;
        </td>
</tr>

<tr>
        <td colspan='2' align='left'>$Lang::tr{'copfilter warning'}</td>
</tr>
</table>

<form method='post' action='/cgi-bin/copfilter_status.cgi' enctype='multipart/form-data'>
<table width='100%' cellspacing='9' cellpadding='9'>

<tr>
END
;
	print "<td width='15%' align='center' style='line-height:150%;'><input style='width:100%;' type='submit' name='ACTION' value='$Lang::tr{'copfilter show virus quarantine'}'><br>";
	if ( $nbr_virus gt 0){
	print "<b>(${nbr_virus}x)</b></td>";
	}else{
	print "&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; </td>";}
	print "<td width='15%' align='center' style='line-height:150%;'><input style='width:100%;' type='submit' name='ACTION' value='$Lang::tr{'copfilter show spam quarantine'}'><br>";
	if ( $nbr_spams gt 0){
	print "<b>(${nbr_spams}x)</b></td>";
	}else{
	print "&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; </td>";}
	print "<td width='5%'></td>";
	print "<td width='20%' align='center' style='line-height:150%;'><h3>";
	print $Lang::tr{'copfilter monit_enable1'};
	print $netsettings{'GREEN_ADDRESS'};
	print $Lang::tr{'copfilter monit_enable2'};


print <<END
	</h3><br>
    </td></b>
        <td width='20%' align='center' style='line-height:150%;'> <h3>$Lang::tr{'copfilter whitelist manager'}</h3><br></td>
        <td width='20%' align='center' style='line-height:150%;'> <h3>$Lang::tr{'copfilter digest manager'}</h3><br></td>
	<td width='5%'></td>
</font>
</tr>
</tr>
</style>
</table>
</form>

<!-- 
<br />
<br />
<table>
<tr>
        <td>$Lang::tr{'copfilter usage'}</td>
</tr>
</table>
-->
END
;


#&Header::closebox();
#print "<br />";



################################################################################
##  Website - Status
################################################################################
#print "<a name='status'/>";
#&Header::openbox('100%', 'left', "$Lang::tr{'copfilter status'}:");
print "<form method='post' action='/cgi-bin/copfilter_status.cgi' enctype='multipart/form-data'>";
print <<END

<table width='100%' border='0' cellpadding='4'>
<tr>
        <td align='left' width='12%'><b>$Lang::tr{'copfilter product'}</b></td>
        <td align='left' width='20%'><b>$Lang::tr{'copfilter description'}</b></td>
        <td align='left' width='10%'><b>$Lang::tr{'copfilter daemon'}</b></td>
        <td align='left' width='8%'><b>$Lang::tr{'copfilter version'}</b></td>
        <td align='left' width='30%'><b>$Lang::tr{'copfilter status'}</b></td>
        <td align='left' width='14%'><b>$Lang::tr{'copfilter manual control'}</b></td>
        <td align='left' width='6%'></td>
</tr>

<tr>
        <td align='left'><a href='http://www.tildeslash.com/monit' target='_blank'>monit</a></td>
        <td align='left'>$Lang::tr{'copfilter monit des'}</td>
        <td align='left'>monit</td>
        <td align='left'>
END
;
$output = `/var/log/copfilter/default/opt/monit/default/bin/monit -V |head -1|sed -e 's/.* \\([.0-9]*\\)/\\1/'`;
print "$output\n";
print "</td>\n";

print "<td align='left'>\n";
$output = `/etc/rc.d/init.d/copfilter_monit pid weboutput`;
print "$output\n";

print "</td>";
print "<td colspan='1' >\n";
if ( $output =~ /OFF/) { print "<input style='width:100%;' type='submit' name='ACTION' value='$Lang::tr{'copfilter start monit'}' />\n"; }
else { print "<input style='width:100%;' type='submit' name='ACTION' value='$Lang::tr{'copfilter stop monit'}' />\n"; }

print <<END
</td></tr>
<tr>
        <td align='left'><a href='http://p3scan.sourceforge.net' target='_blank'>P3Scan</a></td>
        <td align='left'>$Lang::tr{'copfilter p3scan des'}</td>
        <td align='left'>p3scan</td>
        <td align='left'>
END
;
$output = `/var/log/copfilter/default/opt/p3scan/default/sbin/p3scan -v |sed  -n 's/P3Scan //p'`;
print "$output\n";
print "</td>\n";

print "<td align='left'>\n";
$output = `/etc/rc.d/init.d/copfilter_p3scan pid weboutput`;
print "$output\n";

print "</td>";
print "<td colspan='1' >\n";
if ( $output =~ /OFF/) { print "<input style='width:100%;' type='submit' name='ACTION' value='$Lang::tr{'copfilter start p3scan'}' />\n"; }
else { print "<input style='width:100%;' type='submit' name='ACTION' value='$Lang::tr{'copfilter stop p3scan'}' />\n"; }

print <<END
</td></tr>

<tr>
        <td align='left'><a href='http://memberwebs.com/nielsen/software/proxsmtp' target='_blank'>ProxSMTP</a></td>
        <td align='left'>$Lang::tr{'copfilter proxsmtpd des'}</td>
        <td align='left'>proxsmtpd</td>
        <td align='left'>
END
;
$output = `/var/log/copfilter/default/opt/proxsmtp/default/sbin/proxsmtpd -v |sed  -n 's/.*version //p'  |sed -e 's/)//'`;
print "$output\n";
print "</td>\n";

print "<td align='left'>\n";
$output = `/etc/rc.d/init.d/copfilter_proxsmtpd pid weboutput`;
print "$output\n";
print "</td>";

print "<td colspan='1' >\n";
if ( $output =~ /OFF/) { print "<input style='width:100%;' type='submit' name='ACTION' value='$Lang::tr{'copfilter start proxsmtpd'}' />\n"; }
else { print "<input style='width:100%;' type='submit' name='ACTION' value='$Lang::tr{'copfilter stop proxsmtpd'}' />\n"; }

print <<END
</td></tr>
<tr>
        <td align='left'><a href='http://www.squid.org' target='_blank'>Squid</a></td>
        <td align='left'>$Lang::tr{'copfilter squid des'}</td>
        <td align='left'>squid</td>
        <td align='left'>
END
;
$output = `/usr/sbin/squid -v |grep -E "Squid Cache: Version"| cut -d " " -f4`;
print "$output\n";
print "</td>\n";

print "<td align='left'>\n";
$pid = `ps --no-header -C squid | cut -d "\x0A" -f1-7 | sed -e 's/[a-zA-Z? ]//g' -e 's/[0-9][0-9]:[0-9][0-9]:[0-9][0-9]//g'`;
chop($pid);

if ( $pid ne '')
{$output = "<font color='#339933'><b>ON</b>  (PID $pid ... )</font>";
}else{
$output = "<font color='#993333'><b>OFF</b></font>";}

print "$output\n";

print "</td>";
print "<td colspan='1' >\n";
if ( $output =~ /OFF/) { print "<input style='width:100%;' type='submit' name='ACTION' value='$Lang::tr{'copfilter restart squid'}' />\n"; }
else { print "<input style='width:100%;' type='submit' name='ACTION' value='$Lang::tr{'copfilter restart squid'}' />\n"; }




print <<END
</td></tr>

<tr>
        <td align='left'><a href='http://havp.sourceforge.net/' target='_blank'>HAVP</a></td>
        <td align='left'>$Lang::tr{'copfilter havp des'}</td>
        <td align='left'>havp</td>
        <td align='left'>
END
;
$output = `LD_LIBRARY_PATH=/var/log/copfilter/default/opt/clamav/default/lib /var/log/copfilter/default/opt/havp/default/sbin/havp -h |grep Version|sed -e 's/HAVP Version \\(.*\\)/\\1/'`;
print "$output\n";
print "</td>\n";

print "<td align='left'>\n";
$output = `/etc/rc.d/init.d/copfilter_havp pid weboutput`;
print "$output\n";
print "</td>";

print "<td colspan='1' >\n";
if ( $output =~ /OFF/) { print "<input style='width:100%;' type='submit' name='ACTION' value='$Lang::tr{'copfilter start havp'}' />\n"; }
else { print "<input style='width:100%;' type='submit' name='ACTION' value='$Lang::tr{'copfilter stop havp'}' />\n"; }

print <<END
</td></tr>

<tr>
        <td align='left'><a href='http://www.privoxy.org' target='_blank'>Privoxy</a></td>
        <td align='left'>$Lang::tr{'copfilter privoxy des'}</td>
        <td align='left'>privoxy</td>
        <td align='left'>
END
;
$output = `/var/log/copfilter/default/opt/privoxy/default/sbin/privoxy --version |sed -e 's/.* \\([0-9].*[0-9a-zA-Z]\\) .*/\\1/'`;
print "$output\n";
print "</td>\n";

print "<td align='left'>\n";
$output = `/etc/rc.d/init.d/copfilter_privoxy pid weboutput`;
print "$output\n";
print "</td>";

print "<td colspan='1' >\n";
if ( $output =~ /OFF/) { print "<input style='width:100%;' type='submit' name='ACTION' value='$Lang::tr{'copfilter start privoxy'}' />\n"; }
else { print "<input style='width:100%;' type='submit' name='ACTION' value='$Lang::tr{'copfilter stop privoxy'}' />\n"; }

print <<END
</td></tr>

<tr>
        <td align='left'><a href='http://frox.sourceforge.net' target='_blank'>frox</a></td>
        <td align='left'>$Lang::tr{'copfilter frox des'}</td>
        <td align='left'>frox</td>
        <td align='left'>
END
;
$output = `cat /var/log/copfilter/default/opt/frox/CURRENTVERSION`;
print "$output\n";
print "</td>\n";

print "<td align='left'>\n";
$output = `/etc/rc.d/init.d/copfilter_frox pid weboutput`;
print "$output\n";
print "</td>";

print "<td colspan='1' >\n";
if ( $output =~ /OFF/) { print "<input style='width:100%;' type='submit' name='ACTION' value='$Lang::tr{'copfilter start frox'}' />\n"; }
else { print "<input style='width:100%;' type='submit' name='ACTION' value='$Lang::tr{'copfilter stop frox'}' />\n"; }

print <<END
</td></tr>

<tr>
        <td align='left'><a href='http://spamassassin.apache.org' target='_blank'>SpamAssassin</a></td>
        <td align='left'>$Lang::tr{'copfilter spamd des'}</td>
        <td align='left'>spamd</td>
        <td align='left'>
END
;
$output = `/var/log/copfilter/default/opt/mail-spamassassin/default/bin/spamc -V |sed -e 's/.* \\([0-9].*\\)/\\1/'`;
print "$output\n";
print "</td>\n";

print "<td align='left'>\n";
$output = `/etc/rc.d/init.d/copfilter_spamd pid weboutput`;
print "$output\n";
print "</td>";

print "<td colspan='1' >\n";
if ( $output =~ /OFF/) { print "<input style='width:100%;' type='submit' name='ACTION' value='$Lang::tr{'copfilter start spamd'}' />\n"; }
else { print "<input style='width:100%;' type='submit' name='ACTION' value='$Lang::tr{'copfilter stop spamd'}' />\n"; }

print <<END
</td></tr>

<tr>
        <td align='left'><a href='http://clamav.sourceforge.net' target='_blank'>ClamAV</a></td>
        <td align='left'>$Lang::tr{'copfilter clamd des'}</td>
        <td align='left'>clamd</td>
        <td align='left'>
END
;
$output = `/var/log/copfilter/default/opt/clamav/default/sbin/clamd -V |sed -e 's/.* \\([0-9].*\\)\\/.*/\\1/'`;
print "$output\n";
print "</td>\n";

print "<td align='left'>\n";
$output = `/etc/rc.d/init.d/copfilter_clamd pid weboutput`;
print "$output\n";
print "</td>";

print "<td colspan='1' >\n";
if ( $output =~ /OFF/) { print "<input style='width:100%;' type='submit' name='ACTION' value='$Lang::tr{'copfilter start clamd'}' />\n"; }
else { print "<input style='width:100%;' type='submit' name='ACTION' value='$Lang::tr{'copfilter stop clamd'}' />\n"; }

print "</td></tr>\n";

# AVG
if ($copfiltersettings{'AVG_INSTALLED'} eq 'yes' ) {


if ( -e "${copfilter_swroot}/opt/avg/default/bin/avgscan") {

print <<END
<tr>
        <td align='left'><a href='http://www3.grisoft.com/doc/buy/us/crp/0' target='_blank'>AVG**</a></td>
        <td align='left'>$Lang::tr{'copfilter avg des'}</td>
        <td align='left'>avgscan</td>
END
;
print "<td align='left'>";
$output = `cat /var/log/copfilter/default/opt/avg/CURRENTVERSION |sed -n '/Program/p' |sed -e 's/Program version \\(.*\\),.*/\\1/'`;
print "$output";
print "</td>\n";


print "<td align='left'>\n";
$output = `/etc/rc.d/init.d/copfilter_avgscan pid weboutput`;
print "$output\n";
print "</td>";

print "<td colspan='1' >\n";
if ( $output =~ /OFF/) { print "<input style='width:100%;' type='submit' name='ACTION' value='$Lang::tr{'copfilter start avgscan'}' />\n"; }
else { print "<input style='width:100%;' type='submit' name='ACTION' value='$Lang::tr{'copfilter stop avgscan'}' />\n"; }
}


print "<td> <font size='3'> &nbsp;</font> </td>\n";
print "</tr>\n";
}

# F-Prot
if ($copfiltersettings{'FPROT_INSTALLED'} eq 'yes' ) {


if ( -e "${copfilter_swroot}/opt/f-prot/default/fpscand" ) {

print <<END
<tr>
        <td align='left'><a href='http://www.f-prot.com/products/home_use/linux' target='_blank'>F-PROT***</a></td>
        <td align='left'>$Lang::tr{'copfilter fprot des'}</td>
        <td align='left'>fpscand</td>
END
;
print "<td align='left'>";
$output = `/var/log/copfilter/default/opt/f-prot/default/fpscan --version | grep -E "^F-P" | cut -d "," -f1 | sed -e 's/[a-zA-Z -]//g'`;
print "$output";
print "</td>\n";


print "<td align='left'>\n";
$output = `/etc/rc.d/init.d/copfilter_f-protd pid weboutput`;
print "$output\n";
print "</td>";

print "<td colspan='1' >\n";
if ( $output =~ /OFF/) { print "<input style='width:100%;' type='submit' name='ACTION' value='$Lang::tr{'copfilter start f-protd'}' />\n"; }
else { print "<input style='width:100%;' type='submit' name='ACTION' value='$Lang::tr{'copfilter stop f-protd'}' />\n"; }

}



else {
print <<END
<tr>
        <td align='left'><a href='http://www.f-prot.com/products/home_use/linux' target='_blank'>F-PROT***</a></td>
        <td align='left'>$Lang::tr{'copfilter fprot des'}</td>
        <td align='left'>no daemon</td>
END
;
print "<td align='left'>";
$output = `/var/log/copfilter/default/opt/f-prot/default/fpscan --version | grep -E "^F-P" | cut -d "," -f1 | sed -e 's/[a-zA-Z -]//g'`;
print "$output";
print "</td>\n";


if ($copfiltersettings{'FPROT_ENABLE'} eq "on" ) {
   if ($copfiltersettings{'SMTP_VIRUS_SCAN'} eq "on" || $copfiltersettings{'POP3_VIRUS_SCAN'} eq "on" ) {
      print "<td><font color='#339933'><b>$Lang::tr{'copfilter status_on_access'}</b>  (no pid)</font> </td>\n";
   }
   else {
      print "<td><font color='#993333'><b>OFF</b></font></td>\n";
      }
}
else {
   print "<td><font color='#993333'><b>OFF</b></font></td>\n";
}
}

print "<td> <font size='3'> &nbsp;</font> </td>\n";
print "</tr>\n";
}



print <<END




<tr>
        <td align='left'><a href='http://www.imspector.org/wordpress' target='_blank'>Imspector</a></td>
        <td align='left'>$Lang::tr{'copfilter imspector des'}</td>
        <td align='left'>imspector</td>
END
;
print "<td align='left'>";
$output = `ls -al /var/log/copfilter/default/opt/imspector | grep default | sed -e 's|\/| |g' | awk '{ print \$11 }'`;
print "$output";
print "</td>\n";

print "<td align='left'>\n";
$output = `/etc/rc.d/init.d/copfilter_imspector pid weboutput`;
print "$output\n";
print "</td>";

print "<td colspan='1' >\n";
#if ( $output =~ /OFF/) { print "<input style='width:100%;' type='submit' name='ACTION' value='$Lang::tr{'copfilter start imspector'}' />\n"; }
#else { print "<input style='width:100%;' type='submit' name='ACTION' value='$Lang::tr{'copfilter stop imspector'}' />\n"; }

#print "<td> <font size='3'> &nbsp;</font> </td>\n";
#print "</tr>\n";











print <<END
<tr>
        <td align='left'><a href='http://www.pc-tools.net/unix/renattach' target='_blank'>Renattach</a></td>
        <td align='left'>$Lang::tr{'copfilter renattach des'}</td>
        <td align='left'>no daemon</td>
        <td align='left'>
END
;
$output = `/var/log/copfilter/default/opt/tools/bin/renattach -V |sed -n '/renattach/p'|sed -e 's/.* \\(.*\\)/\\1/'`;
print "$output\n";
print "</td>\n";

if ($copfiltersettings{'SMTP_ATTACHMENT_SCAN'} eq "on" || $copfiltersettings{'POP3_ATTACHMENT_SCAN'} eq "on" ) {
   print "<td><font color='#339933'><b>$Lang::tr{'copfilter status_on_access'}</b>  (no pid)</font> </td>\n";
   }
else {
   print "<td><font color='#993333'><b>OFF</b></font></td>\n";
   }

print <<END
        <td colspan='1'><input style='width:100%;' type='submit' name='ACTION' value='$Lang::tr{'copfilter apply'}'></td>
</tr>
<tr>
	<td></td><td></td><td></td><td></td><td></td><td colspan='2'>$Lang::tr{'copfilter apply2'}</td>
</tr>

END
;

if ( $thrdp_clamav eq 0 || $thrdp_privoxy eq 0 || $thrdp_sarules eq 0) {
print <<END
	<tr>
	<td colspan='3'>$Lang::tr{'copfilter mods'}</td> 
	</tr>
END
;
if ($thrdp_sarules eq 0){
$output = '';
$output = `cat /var/log/copfilter/default/opt/tools/bin/check-updates_rulesdujour.sh | grep "RDJ_VERSION" | cut -d "=" -f2`;
$pid = `pidof fcron`;
chop($pid);
print <<END
	<tr>
        <td align='left'><a href='http://wiki.apache.org/spamassassin/RuleUpdates' target='_blank'>SA Rules</a></td>
        <td align='left'>$Lang::tr{'copfilter rules_du_jour des'}</td>
        <td align='left'>fcron</td>
	<td align='left'>$output</td>
END
;
	if ($copfiltersettings{'RULES_DU_JOUR_UPDATE_METHOD'} eq 'periodically'){
	print "<td><font color='#339933'><b>ON CRON JOB</b>  (PID $pid)</font> </td>";}else{
	print "<td><font color='#993333'><b>OFF</b></font></td>";}
	print "</tr>";}


if ($thrdp_clamav eq 0){
$output = '';
$output = $copfiltersettings{'THRDP_VERSION'};
$pid = `pidof fcron`;
chop($pid);
if ( $copfiltersettings{'CLAMD_ENABLE'} eq 'on' && $copfiltersettings{'CLAMD_PHISHING_SIGS'} eq 'on'){
$thrdp_mod_on = "<td><font color='#339933'><b>ON CRON JOB</b>  (PID $pid)</font> </td>";
}else{
$thrdp_mod_on = "<td><font color='#993333'><b>OFF</b></font></td>";}
print <<END
	<tr>
        <td align='left'>ClamAV 3rd-party-mod</td>
        <td align='left'>$Lang::tr{'copfilter thrdp clamav des'}</td>
        <td align='left'>fcron</td>
	<td align='left'>$output</td>
	$thrdp_mod_on
	</tr>
END
;
}


if ($thrdp_privoxy eq 0){
$output = $copfiltersettings{'RULES_VERSION'};
$pid = `pidof fcron`;
chop($pid);
if ( $copfiltersettings{'PRIVOXY_ENABLE'} eq 'on'){
$thrdp_mod_on = "<td><font color='#339933'><b>ON CRON JOB</b>  (PID $pid)</font> </td>";
}else{
$thrdp_mod_on = "<td><font color='#993333'><b>OFF</b></font></td>";}
print <<END
	<tr>
        <td align='left'>Privoxy mod</td>
        <td align='left'>$Lang::tr{'copfilter thrdp privoxy des'}</td>
        <td align='left'>fcron</td>
	<td align='left'>$output</td>
	$thrdp_mod_on
	</tr>
END
;
}
print "<tr><td> &nbsp;</td></tr>";
}

print <<END


<tr>
	<td> &nbsp;</td>
</tr>
<tr>
	<td colspan='5'> $Lang::tr{'copfilter all_stats'}</td>
</tr>
<tr>
	<td> &nbsp;</td>
</tr>
<tr>
	<td colspan='5'> 

END
;

if ( $copfiltersettings{'EMAIL_ADR'} eq '' )
{
    print $Lang::tr{'copfilter missing_mail'};
}

if ($copfiltersettings{'SMTP_HOST'} =~ /^$/)
{
    print $Lang::tr{'copfilter missing_smtp_host'};
}




if ( $copfiltersettings{'CLAMD_ENABLE'} eq 'off' && $copfiltersettings{'AVG_ENABLE'} eq 'off' && $copfiltersettings{'FPROT_ENABLE'} eq 'off' && 
     ( $copfiltersettings{'POP3_VIRUS_SCAN'} eq 'on' ||  
       $copfiltersettings{'SMTP_VIRUS_SCAN'} eq 'on' ||  
       $copfiltersettings{'FTP_VIRUS_SCAN'} eq 'on' ) )
{

    print $Lang::tr{'copfilter missing virusscanner'};
}


print <<END
    
    &nbsp;</td>
</tr>

<tr>
	<td> &nbsp;</td>
</tr>

<tr>
	<td colspan='5'>$Lang::tr{'copfilter status2'}</td>
</tr>
<tr>
	<td colspan='5'>$Lang::tr{'copfilter status11'} </td>
</tr>



<tr>
	<td colspan='5'>$Lang::tr{'copfilter status1'} </td>
</tr>

<tr>
	<td colspan='5'>$Lang::tr{'copfilter status3'} </td>
</tr>

<tr>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
</tr>



</table>
END
;

print "</form>\n";
&Header::closebox();
print "<br />";

system('rm -f /tmp/count.aid >/dev/null 2>&1');

# For Testing
#print "<pre>";
#$output = `cat /var/log/copfilter/default/etc/global_settings`;
#print "$output\n";
#print "</pre>";
&Header::closebigbox();

&Header::closepage();


}
