#!/usr/bin/perl
#
# SmoothWall CGIs
#
# This code is distributed under the terms of the GPL
#
# (c) The SmoothWall Team
#
# $Id: copfilter.cgi,v 0.00.0.3 2005/03/15 mmadlener
#

# Add entry in menu
# MENUENTRY copfilter 100 "Antispam" "copfilter antispam"

#
# Make sure translation exists $Lang::tr{'copfilter antispam'}


use strict;
use IO::Socket;
# enable only the following on debugging purpose
#use warnings;
#use CGI::Carp 'fatalsToBrowser';



################################################################################
##   Definitions
################################################################################

require '/usr/lib/ipcop/general-functions.pl';
require "/usr/lib/ipcop/lang.pl";
require "/usr/lib/ipcop/header.pl";

my ($copfilter_swroot);
my %copfiltersettings=();
my %netsettings=();
my (%selected,%checked)=();
my $errormessage = '';
my $output = '';
my $sortorder = '2';
$copfiltersettings{'ACTION'} = '';


$copfilter_swroot = '/var/log/copfilter/default';

&General::readhash("${General::swroot}/ethernet/settings", \%netsettings);
&General::readhash("${copfilter_swroot}/etc/global_settings", \%copfiltersettings);
$copfiltersettings{'SPAM_SCORE_BAYES_00'} = sprintf("%.3f",$copfiltersettings{'SPAM_SCORE_BAYES_00'});
$copfiltersettings{'SPAM_SCORE_BAYES_05'} = sprintf("%.3f",$copfiltersettings{'SPAM_SCORE_BAYES_05'});
$copfiltersettings{'SPAM_SCORE_BAYES_20'} = sprintf("%.3f",$copfiltersettings{'SPAM_SCORE_BAYES_20'});
$copfiltersettings{'SPAM_SCORE_BAYES_40'} = sprintf("%.3f",$copfiltersettings{'SPAM_SCORE_BAYES_40'});
$copfiltersettings{'SPAM_SCORE_BAYES_50'} = sprintf("%.3f",$copfiltersettings{'SPAM_SCORE_BAYES_50'});
$copfiltersettings{'SPAM_SCORE_BAYES_60'} = sprintf("%.3f",$copfiltersettings{'SPAM_SCORE_BAYES_60'});
$copfiltersettings{'SPAM_SCORE_BAYES_80'} = sprintf("%.3f",$copfiltersettings{'SPAM_SCORE_BAYES_80'});
$copfiltersettings{'SPAM_SCORE_BAYES_95'} = sprintf("%.3f",$copfiltersettings{'SPAM_SCORE_BAYES_95'});
$copfiltersettings{'SPAM_SCORE_BAYES_99'} = sprintf("%.3f",$copfiltersettings{'SPAM_SCORE_BAYES_99'});
if ($copfiltersettings{'SPAM_SCAN_RBL'} eq '') { $copfiltersettings{'SPAM_SCAN_RBL'} = 'off'; }
#&General::writehash("/tmp/before_cgi", \%copfiltersettings);
$copfiltersettings{'SKIP_RESTART'}='off';
&General::getcgihash(\%copfiltersettings);

#testing
#my %copfiltersettings2=();
#&General::readhash("${copfilter_swroot}/etc/global_settings", \%copfiltersettings3);
#&Header::getcgihash(\%copfiltersettings2);
#&General::writehash("/tmp/after_cgi", \%copfiltersettings);
#&General::writehash("/tmp/cgi", \%copfiltersettings2);


&Header::showhttpheaders();
&Header::openpage('Copfilter', 1, '');


#sub copfilter_set_lang {

package Lang;

### Initialize language
%Lang::tr = ();
    our $language;
    my %settings = ();
    &General::readhash("${General::swroot}/main/settings", \%settings);
    $language = $settings{'LANGUAGE'};
    if ($language =~ /^(\w+)$/) {$language = $1;}
    do "${copfilter_swroot}/langs/en.pl";
    do "${copfilter_swroot}/langs/${language}.pl";
1;
#}
#
#copfilter_set_lang();






################################################################################
##   Substitutions
################################################################################


sub copfilter_start_log
{

	&Header::openbigbox('100%', 'left');
	&Header::openbox('100%', 'left', "$Lang::tr{'copfilter'}:");
	print "<H1>  $Lang::tr{'copfilter log'}: </H1>\n";
}

sub copfilter_stop_log
{
        print "<br /><br />";
        #system('echo "<A HREF=$HTTP_REFERER> Back to the copfilter configuration page </A>"');
        print "<A HREF='/cgi-bin/copfilter_antispam.cgi' > $Lang::tr{'copfilter back'} </A>\n";
        print "<br /><br />";

        &Header::closebox();
        &Header::closebigbox();
        &Header::closepage();
}


sub writehashsorted
{
        my $filename = $_[0];
        my $hash = $_[1];
        my ($var, $val);


        # write cgi vars to the file.
        open(FILE, ">${filename}") or die "Unable to write file $filename";
        flock FILE, 2;
        foreach $var (sort (keys %$hash))
        {
                $val = $hash->{$var};
                # Darren Critchley Jan 17, 2003 added the following because when submitting with a graphic, the x and y
                # location of the mouse are submitted as well, this was being written to the settings file causing
                # some serious grief! This skips the variable.x and variable.y
                if (!($var =~ /(.x|.y)$/)) {
                        if ($val =~ / /) {
                                $val = "\'$val\'"; }
                        if (!($var =~ /^ACTION/)) {
                                print FILE "${var}=${val}\n"; }
                }
        }
        close FILE;
}

sub count_files
{
    my $dir = shift;
    my $ext = shift;

    my ($count, $file);

    $count = 0;
    if (system ("ls " . $dir . " >>/tmp/count.aid 2>&1") eq 0 )
    {
       opendir(BIN, $dir) or die "Can't open $dir: $!";
       foreach my $file (grep {/\.$ext$/} readdir BIN)
       {
	    $count++;
	   
       }
       closedir(BIN);
    }
    else
    {
       print "<br /><P> $Lang::tr{'copfilter show quarantine error'} \n";
       print $dir . "</P>\n";
    }
    return $count;
}

sub count_files_type
{
    my $ext = shift;

    my ($dir_spam1, $dir_spam2);

    $dir_spam1 = "/var/log/copfilter/default/opt/p3scan/quarantine";
    $dir_spam2 = "/var/log/copfilter/default/opt/proxsmtp/quarantine";
    return count_files($dir_spam1, $ext) + count_files($dir_spam2, $ext);
}

sub count_spams()
{
    return count_files_type("spam");
}



my $nbr_spams = count_spams();

######### SPAM_SCAN_SCORE_LEVEL
for(my $i = 1; $i <= 40; $i++)
{
   $selected{'SPAM_SCAN_SCORE_LEVEL'}{$i} = '';
}
$selected{'SPAM_SCAN_SCORE_LEVEL'}{$copfiltersettings{'SPAM_SCAN_SCORE_LEVEL'}} = "selected='selected'";

######### RULES_DU_JOUR_ENABLE
$selected{'RULES_DU_JOUR_ENABLE'}{'off'} = '';
$selected{'RULES_DU_JOUR_ENABLE'}{'on'} = '';
$selected{'RULES_DU_JOUR_ENABLE'}{$copfiltersettings{'RULES_DU_JOUR_ENABLE'}} = "selected='selected'";
if ($copfiltersettings{'RULES_DU_JOUR_ENABLE'} ne 'on' ) {
system('cat /var/log/copfilter/default/etc/global_settings | sed "s/^RULES_DU_JOUR_ENABLE=.*$/RULES_DU_JOUR_ENABLE=on/" > /tmp/global_settings');
system('chown nobody.nobody /tmp/global_settings');
system('mv -f /tmp/global_settings /var/log/copfilter/default/etc/global_settings');
}

######### RULES_GERMAN_ENABLE
#$selected{'RULES_GERMAN_ENABLE'}{'off'} = '';
#$selected{'RULES_GERMAN_ENABLE'}{'on'} = '';
#$selected{'RULES_GERMAN_ENABLE'}{$copfiltersettings{'RULES_GERMAN_ENABLE'}} = "selected='selected'";

$selected{'RULES_DU_JOUR_UPDATE_METHOD'}{'manually'} = '';
$selected{'RULES_DU_JOUR_UPDATE_METHOD'}{'periodically'} = '';
$selected{'RULES_DU_JOUR_UPDATE_METHOD'}{$copfiltersettings{'RULES_DU_JOUR_UPDATE_METHOD'}} = "checked='checked'";

$selected{'RULES_DU_JOUR_UPDATE_PERIOD'}{'hourly'} = '';
$selected{'RULES_DU_JOUR_UPDATE_PERIOD'}{'daily'} = '';
$selected{'RULES_DU_JOUR_UPDATE_PERIOD'}{'weekly'} = '';
$selected{'RULES_DU_JOUR_UPDATE_PERIOD'}{'monthly'} = '';
$selected{'RULES_DU_JOUR_UPDATE_PERIOD'}{$copfiltersettings{'RULES_DU_JOUR_UPDATE_PERIOD'}} = "selected='selected'";

######### SPAM_SCAN_SPEEDUP
$selected{'SPAM_SCAN_SPEEDUP'}{'GREEN'} = '';
$selected{'SPAM_SCAN_SPEEDUP'}{'ORANGE'} = '';
$selected{'SPAM_SCAN_SPEEDUP'}{$copfiltersettings{'SPAM_SCAN_SPEEDUP'}} = "selected='selected'";

######### SPAM_SCAN_RBL
$selected{'SPAM_SCAN_RBL'}{'GREEN'} = '';
$selected{'SPAM_SCAN_RBL'}{'ORANGE'} = '';
$selected{'SPAM_SCAN_RBL'}{$copfiltersettings{'SPAM_SCAN_RBL'}} = "selected='selected'";

######### IMAP_ENABLE
$selected{'IMAP_ENABLE'}{'off'} = '';
$selected{'IMAP_ENABLE'}{'on'} = '';
$selected{'IMAP_ENABLE'}{$copfiltersettings{'IMAP_ENABLE'}} = "selected='selected'";

######### IMAP_DEBUG
$selected{'IMAP_DEBUG'}{'off'} = '';
$selected{'IMAP_DEBUG'}{'on'} = '';
$selected{'IMAP_DEBUG'}{$copfiltersettings{'IMAP_DEBUG'}} = "selected='selected'";

######### IMAP_DAILY
$selected{'IMAP_DAILY'}{'off'} = '';
$selected{'IMAP_DAILY'}{'on'} = '';
$selected{'IMAP_DAILY'}{$copfiltersettings{'IMAP_DAILY'}} = "selected='selected'";

######### IMAP_SSL
$selected{'IMAP_SSL'}{'off'} = '';
$selected{'IMAP_SSL'}{'on'} = '';
$selected{'IMAP_SSL'}{$copfiltersettings{'IMAP_SSL'}} = "selected='selected'";

######### SPAM_DAILY_DIGEST
$selected{'SPAM_DAILY_DIGEST'}{'off'} = '';
$selected{'SPAM_DAILY_DIGEST'}{'on'} = '';
$selected{'SPAM_DAILY_DIGEST'}{$copfiltersettings{'SPAM_DAILY_DIGEST'}} = "selected='selected'";

######### SPAMD_ENABLE
$selected{'SPAMD_ENABLE'}{'off'} = '';
$selected{'SPAMD_ENABLE'}{'on'} = '';
$selected{'SPAMD_ENABLE'}{$copfiltersettings{'SPAMD_ENABLE'}} = "selected='selected'";

######### SPAM_SCORE_BAYES_00
for(my $j = -50; $j <= -10; $j++)
{
	my $jj = $j / 10;
	$selected{'SPAM_SCORE_BAYES_00'}{$jj} = '';
}
$selected{'SPAM_SCORE_BAYES_00'}{$copfiltersettings{'SPAM_SCORE_BAYES_00'}} = "selected='selected'";

######### SPAM_SCORE_BAYES_05
for(my $k = -40; $k <= 0; $k++)
{
	my $kk = $k / 10;
	$selected{'SPAM_SCORE_BAYES_05'}{$kk} = '';
}
$selected{'SPAM_SCORE_BAYES_05'}{$copfiltersettings{'SPAM_SCORE_BAYES_05'}} = "selected='selected'";

######### SPAM_SCORE_BAYES_20
for(my $l = -30; $l <= 10; $l++)
{
	my $ll = $l / 10;
	$selected{'SPAM_SCORE_BAYES_20'}{$ll} = '';
}
$selected{'SPAM_SCORE_BAYES_20'}{$copfiltersettings{'SPAM_SCORE_BAYES_20'}} = "selected='selected'";

######### SPAM_SCORE_BAYES_40
for(my $m = -20; $m <= 20; $m++)
{
	my $mm = $m / 10;
	$selected{'SPAM_SCORE_BAYES_40'}{$mm} = '';
}
$selected{'SPAM_SCORE_BAYES_40'}{$copfiltersettings{'SPAM_SCORE_BAYES_40'}} = "selected='selected'";

######### SPAM_SCORE_BAYES_50
for(my $n = 0; $n <= 40; $n++)
{
	my $nn = $n / 10;
	$selected{'SPAM_SCORE_BAYES_50'}{$nn} = '';
}
$selected{'SPAM_SCORE_BAYES_50'}{$copfiltersettings{'SPAM_SCORE_BAYES_50'}} = "selected='selected'";

######### SPAM_SCORE_BAYES_60
for(my $o = 10; $o <= 50; $o++)
{
	my $oo = $o / 10;
	$selected{'SPAM_SCORE_BAYES_60'}{$oo} = '';
}
$selected{'SPAM_SCORE_BAYES_60'}{$copfiltersettings{'SPAM_SCORE_BAYES_60'}} = "selected='selected'";

######### SPAM_SCORE_BAYES_80
for(my $p = 15; $p <= 70; $p++)
{
	my $pp = $p / 10;
	$selected{'SPAM_SCORE_BAYES_80'}{$pp} = '';
}
$selected{'SPAM_SCORE_BAYES_80'}{$copfiltersettings{'SPAM_SCORE_BAYES_80'}} = "selected='selected'";

######### SPAM_SCORE_BAYES_95
for(my $q = 25; $q <= 80; $q++)
{
	my $qq = $q / 10;
	$selected{'SPAM_SCORE_BAYES_95'}{$qq} = '';
}
$selected{'SPAM_SCORE_BAYES_95'}{$copfiltersettings{'SPAM_SCORE_BAYES_95'}} = "selected='selected'";

######### SPAM_SCORE_BAYES_99
for(my $r = 35; $r <= 90; $r++)
{
	my $rr = $r / 10;
	$selected{'SPAM_SCORE_BAYES_99'}{$rr} = '';
}
$selected{'SPAM_SCORE_BAYES_99'}{$copfiltersettings{'SPAM_SCORE_BAYES_99'}} = "selected='selected'";

################################################################################
##   ACTIONs
################################################################################


######### Manual updates (virus scanners and rules_du_jour)


if ($copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter rules_du_jour update now'})
{
        system ('/usr/local/bin/copfilter_check-updates_rulesdujour 2>&1 |logger -t "copfilter rules_du_jour update now" &');
        system ('/usr/bin/touch', "${copfilter_swroot}/etc/copfilter_check-updates_rules_du_jour.done");
        $copfiltersettings{'ACTION'} = '';
}

if ($copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter imap_run_now'})
{
        system ('/usr/local/bin/copfilter_imap_run_now 2>&1 |logger -t "copfilter imap_run_now" &');
        system ('/usr/bin/touch', "${copfilter_swroot}/etc/copfilter_imap_run_now.done");
        $copfiltersettings{'ACTION'} = '';
}


######### send quarantined email
if (    $copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter send q_mail'} )
{
        &copfilter_start_log();
        &writehashsorted("/tmp/env_send_q_mail.tmp", \%copfiltersettings);
        system ('/usr/local/bin/copfilter_send_q_mail');
        &copfilter_stop_log();
}




use File::stat;
use Time::localtime;


####################################
# Sort Spam Quarantine
# by copfilter forum user Taurus
# http://copfilter.endlich-mail.de/viewtopic.php?t=1307
#
if (    $copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter q_subject'} )
{
  if (($sortorder & 127) == 1){ 
###
#
# TODO: To Sort backwards set Bit 7, not working yet
#
###  
    $sortorder = $sortorder ^ 128;
#    print "sort: $sortorder";
  }
  else {  $sortorder = 1;}
#  print "sort!!!$sortorder";
  $copfiltersettings{'ACTION'} = $Lang::tr{'copfilter show spam quarantine'};
}
if (    $copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter q_date'} )
{
  $sortorder = 2;
  $copfiltersettings{'ACTION'} = $Lang::tr{'copfilter show spam quarantine'};
}

if (    $copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter q_from'} )
{
  $sortorder = 3;
  $copfiltersettings{'ACTION'} = $Lang::tr{'copfilter show spam quarantine'};
}
if (    $copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter q_to'} )
{
  $sortorder = 4;
  $copfiltersettings{'ACTION'} = $Lang::tr{'copfilter show spam quarantine'};
}


#--------------------------------
######### Show spam quarantine
my $actstr1 = $copfiltersettings{'ACTION'};
my $compstr1 = $Lang::tr{'copfilter show spam quarantine'};
my $actstr = substr($actstr1, 0, 12);
my $compstr = substr($compstr1, 0, 12);


#if (    $copfiltersettings{'ACTION'} eq "'$Lang::tr{'copfilter show spam quarantine'}'" )
if ( $actstr eq $compstr )
{
        &copfilter_start_log();

if (system ("ls /var/log/copfilter/default/opt/p3scan/quarantine >/dev/null 2>&1") eq 0 )
{

my ($dir, $file, $file2, $hit, $subject, $subject2, $sender, $sender2, $recipient, $recipient2, $date, $date2, @fileliste, @scoreliste, $index1, $nrofspams, $score, $help1, $date3, $sortorder1, $testvar, $testvar2);
#my ($dir, $file, $file2, $hit, $subject, $subject2, $sender, $sender2, $recipient, $recipient2, $date, $date2);
$dir = "/var/log/copfilter/default/opt/p3scan/quarantine";
print "<br />\n";
print "<b>$Lang::tr{'copfilter show spam quarantine'} - POP3 - $dir</b>\n";
print "<br><br>";
print "<form method='post' action='/cgi-bin/copfilter_antispam.cgi' enctype='multipart/form-data'>\n";
print "<table width='100%' cellpadding='2' cellspacing='0' color='#ffffff' border='1'>\n";
print "<TR>\n";
print "<td align='center'>del</td>\n";
print "<td align='center'>send</td>\n";
print "<td align='center'>add</td>\n";
#print "<td align='center'> $Lang::tr{'copfilter q_from'}      </td>\n";
print "<td align='center'> <input type='submit' name='ACTION' value='$Lang::tr{'copfilter q_from'}'   </td>\n";
#print "<td align='center'> $Lang::tr{'copfilter q_to'}       </td>\n";
print "<td align='center'> <input type='submit' name='ACTION' value='$Lang::tr{'copfilter q_to'}'   </td>\n";
#print "<td align='center'> $Lang::tr{'copfilter q_subject'}  </td>\n";
print "<td align='center'> <input type='submit' name='ACTION' value='$Lang::tr{'copfilter q_subject'}'  </td>\n";
#print "<td align='center'> $Lang::tr{'copfilter q_date'}     </td>\n";
print "<td align='center'> <input type='submit' name='ACTION' value='$Lang::tr{'copfilter q_date'}'     </td>\n";
print "<td align='center'> $Lang::tr{'copfilter q_filename'} </td>\n";
print "</TR>\n";

#######################
# Sort
$index1 = 0;
opendir(BIN, $dir) or die "Can't open $dir: $!";
foreach my $file (grep {/\.spam/} readdir BIN){
   $hit = 0;
   $subject = "";
   $subject2 = "";
   $sender = "";
   $recipient = "";
   $date = "";
   $score = "";
   $hit = 1 if -T "$dir/$file";
   if ($hit == 1) {
      open (EP,"$dir/$file");
      while (<EP>) {
         if (/^X-Spam-Status: Yes, score=/i) {
            $_ =~ s/X-Spam-Status: Yes, score=(.+)/$1/i;
	    $score=$_;
	    $score=~ s/_ req.*//i;
         }
        if (/^From: /i) {
            $_ =~ s/.+<(.+)>/$1/i;
            $sender = $_;
         }
#         if (/Envelope-To:/i) {
	 if (($recipient eq "") and (/^To: /i)) {
#            $_ =~ s/.+<(.+)>/$1/i;
#            $_ =~ s/$1/<to:(.+)>/i;

            $_ =~ s/.+<(.+)>/$1/i;
            $_ =~ s/to:(.+)/$1/i;
            $recipient = $_;
         }

	 if (($subject eq "") and (/^Subject: /i)) {
            $_ =~ s/subject:(.+)/$1/i;
            $subject = $_;
         }
         if (/Date:/i) {
            $_ =~ s/date:(.+)/$1/i;
            $date = $_;
         }

      }

#      printf("%02d.%02d.%04d-%02d:%02d:%02d\n",
#      $tm->mday, $tm->mon+1, $tm->year+1900,
#      $tm->hour, $tm->min, $tm->sec);

      my ($sec, $tm);
      $sec = stat("$dir/$file")->mtime;

      $sender2 =  substr($sender, 0, 30);
      $subject2 =  substr($subject, 14, 70);
#      $recipient2 =  substr($recipient, 0, 30);
      $recipient2 =  substr($recipient, 0, 30);
#      if ($recipient2 == "") {$recipient2="aaa";}
      $date2 =  substr($date, 6, 21);
      $file2 =  substr($file, 0, 13);

      $tm = localtime($sec);
      $date3=sprintf("%04d-%02d-%02d  %02d:%02d:%02d\n",
        $tm->year+1900, $tm->mon+1, $tm->mday,
        $tm->hour, $tm->min, $tm->sec);
   }
#   	 print "<";
#	 print $score;
#	 print "> \n";
    if ($recipient2 eq "") {$recipient2="                       ";}
####  
# Add leading Zeros, not nice - but works ;-)
  if (index($score,".") < 2){$score="0".$score;}
  if (index($score,".") < 3){$score="0".$score;}
# $sortorder bestimmt die Sortierung:
# 1 - sortiert nach Score und Datum (aufsteigend)
# 2 - sortiert nach Datum und Score (aufsteigend)  
# 3 - sortiert nach From und Datum(aufsteigend)  
# 4 - sortiert nach To und Score(aufsteigend)  
# 
#  $sortorder1=$sortorder & 127;
   $sortorder1=$sortorder;
# 
#
  if ($sortorder1 == 1) { $scoreliste[$index1]=$score."|".$file; }
  if ($sortorder1 == 2) { 
    $help1=substr($date3,0,18);
    $scoreliste[$index1]=$help1."|".$file; 
  }
  if ($sortorder1 == 3) { $scoreliste[$index1]=$sender2."|".$file; }
 if ($sortorder1 == 4) { 
   #
   $recipient2=~ s/<//;
   $recipient2=~ s/>//;
   $recipient2=~ s/\012//;
   $recipient2=~ s/,//;
   $recipient2=~ s/ //g;
   $scoreliste[$index1]=$recipient2."|".$file; 
 }
#     	 print "<";
#	 print $scoreliste[$index1];
#	 print "> \n";
  $index1++;
}
closedir(BIN);  
$nrofspams=$index1;
#print "-----------------------------------------";
$index1=0;
while ($index1 < $nrofspams){

 # print "$scoreliste[$index1]<TR>\n";
  $index1++;

}


@fileliste=sort{$a cmp $b} @scoreliste;
#if ($sortorder > 128){@fileliste=reverse(@fileliste);}

#print "---------------SORTED--------------------------";

$index1=0;
while ($index1 < $nrofspams){
 # print "+";    
 # print "$fileliste[$index1]<TR>\n";
  $index1++;
}


######################
#opendir(BIN, $dir) or die "Can't open $dir: $!";
$index1=0;
while ($index1 < $nrofspams){
   $help1=$fileliste[$index1];
   #
   # !!!
   #
   $file=substr($help1,index($help1,"|")+1,255);
   $hit = 0;
   $subject = "";
   $subject2 = "";
   $sender = "";
   $recipient = "";
   $date = "";
   $hit = 1 if -T "$dir/$file";

   if ($hit == 1) {
      open (EP,"$dir/$file");
      while (<EP>) {
         if (/^From: /i) {
            $_ =~ s/.+<(.+)>/$1/i;
            $sender = $_;
         }
#         if (/Envelope-To:/i) {
         if (/^To: /i) {
#            $_ =~ s/.+<(.+)>/$1/i;
#            $_ =~ s/$1/<to:(.+)>/i;

            $_ =~ s/.+<(.+)>/$1/i;
            $_ =~ s/to:(.+)/$1/i;
            $recipient = $_;
         }
	 # Bugfix, only the first ^Subject should be used
	 if (($subject eq "") and (/^Subject: /i)) {
              $_ =~ s/subject:(.+)/$1/i;
              $subject = $_;
         }
         if (/Date:/i) {
            $_ =~ s/date:(.+)/$1/i;
            $date = $_;
         }

      }

#      printf("%02d.%02d.%04d-%02d:%02d:%02d\n",
#      $tm->mday, $tm->mon+1, $tm->year+1900,
#      $tm->hour, $tm->min, $tm->sec);

      my ($sec, $tm);
      $sec = stat("$dir/$file")->mtime;

      $sender2 =  substr($sender, 0, 30);
      $subject2 =  substr($subject, 14, 70);
      $recipient2 =  substr($recipient, 0, 30);
      $date2 =  substr($date, 6, 21);
      $file2 =  substr($file, 0, 13);
      print "<TR>\n";
      print "<td class='base' align='center'><input type='checkbox' name='$dir/$file.delete' /></td>";
      print "<td class='base' align='center'><input type='checkbox' name='$dir/$file' /></td>";
      print "<td class='base' align='center'><input type='checkbox' name='$dir/$file.whitelist' /></td>";
      print "<td class='base' align='left'>$sender2</td>";
      print "<td class='base' align='left'>$recipient2</td>";
      print "<td class='base' align='left'>$subject2</td>";
      print "<td class='base' align='left'>";

      $tm = localtime($sec);
      printf("%04d-%02d-%02d  %02d:%02d:%02d\n",
      $tm->year+1900, $tm->mon+1, $tm->mday,
      $tm->hour, $tm->min, $tm->sec);
      print "</td>";
      print "<td class='base' align='left'><a href='/p3scan_quarantine/$file' target='_blank'>$file2</a></td>";
      print "</TR>";
   }
   $index1++;
}
#print "index1=$index1";
#closedir(BIN);
        print "</table>";

}
else
{
print "<br /><P> $Lang::tr{'copfilter show quarantine error'} \n";
print "/var/log/copfilter/default/opt/p3scan/quarantine</P>\n";
}

print "<br />\n";
print "<br />\n";
print "<br />\n";


if ( system ("ls /var/log/copfilter/default/opt/proxsmtp/quarantine >/dev/null 2>&1") eq 0 )
{
my ($dir, $file, $file2, $hit, $subject, $subject2, $sender, $sender2, $recipient, $recipient2, $date, $date2, @fileliste, @scoreliste, $index1, $nrofspams, $score, $help1, $date3, $sortorder1, $testvar, $testvar2);
#my ($dir, $file, $file2, $hit, $subject, $subject2, $sender, $sender2, $recipient, $recipient2, $date, $date2);
$dir = "/var/log/copfilter/default/opt/proxsmtp/quarantine";
print "<b>$Lang::tr{'copfilter show spam quarantine'} - SMTP - $dir</b>\n";
print "<br><br>";
print "<table width='100%' cellpadding='2' cellspacing='0' color='#ffffff' border='1'>\n";
print "<TR>\n";
print "<td align='center'>del</td>\n";
print "<td align='center'>send</td>\n";
print "<td align='center'>add</td>\n";
#print "<td align='center'> $Lang::tr{'copfilter q_from'}      </td>\n";
print "<td align='center'> <input type='submit' name='ACTION' value='$Lang::tr{'copfilter q_from'}'   </td>\n";
#print "<td align='center'> $Lang::tr{'copfilter q_to'}       </td>\n";
print "<td align='center'> <input type='submit' name='ACTION' value='$Lang::tr{'copfilter q_to'}'   </td>\n";
#print "<td align='center'> $Lang::tr{'copfilter q_subject'}  </td>\n";
print "<td align='center'> <input type='submit' name='ACTION' value='$Lang::tr{'copfilter q_subject'}'  </td>\n";
#print "<td align='center'> $Lang::tr{'copfilter q_date'}     </td>\n";
print "<td align='center'> <input type='submit' name='ACTION' value='$Lang::tr{'copfilter q_date'}'     </td>\n";
print "<td align='center'> $Lang::tr{'copfilter q_filename'} </td>\n";
print "</TR>\n";

#######################
# Sort
$index1 = 0;
opendir(BIN, $dir) or die "Can't open $dir: $!";
foreach my $file (grep {/\.spam/} readdir BIN){
   $hit = 0;
   $subject = "";
   $subject2 = "";
   $sender = "";
   $recipient = "";
   $date = "";
   $score = "";
   $hit = 1 if -T "$dir/$file";
   if ($hit == 1) {
      open (EP,"$dir/$file");
      while (<EP>) {
         if (/^X-Spam-Status: Yes, score=/i) {
            $_ =~ s/X-Spam-Status: Yes, score=(.+)/$1/i;
	    $score=$_;
	    $score=~ s/_ req.*//i;
         }
        if (/^From: /i) {
            $_ =~ s/.+<(.+)>/$1/i;
            $sender = $_;
         }
#         if (/Envelope-To:/i) {
	 if (($recipient eq "") and (/^To: /i)) {
#            $_ =~ s/.+<(.+)>/$1/i;
#            $_ =~ s/$1/<to:(.+)>/i;

            $_ =~ s/.+<(.+)>/$1/i;
            $_ =~ s/to:(.+)/$1/i;
            $recipient = $_;
         }

	 if (($subject eq "") and (/^Subject: /i)) {
            $_ =~ s/subject:(.+)/$1/i;
            $subject = $_;
         }
         if (/Date:/i) {
            $_ =~ s/date:(.+)/$1/i;
            $date = $_;
         }

      }

#      printf("%02d.%02d.%04d-%02d:%02d:%02d\n",
#      $tm->mday, $tm->mon+1, $tm->year+1900,
#      $tm->hour, $tm->min, $tm->sec);

      my ($sec, $tm);
      $sec = stat("$dir/$file")->mtime;

      $sender2 =  substr($sender, 0, 30);
      $subject2 =  substr($subject, 14, 70);
#      $recipient2 =  substr($recipient, 0, 30);
      $recipient2 =  substr($recipient, 0, 30);
#      if ($recipient2 == "") {$recipient2="aaa";}
      $date2 =  substr($date, 6, 21);
      $file2 =  substr($file, 0, 13);

      $tm = localtime($sec);
      $date3=sprintf("%04d%02d%02d_%02d:%02d:%02d\n",
        $tm->year+1900, $tm->mon+1, $tm->mday,
        $tm->hour, $tm->min, $tm->sec);
   }
#   	 print "<";
#	 print $score;
#	 print "> \n";
    if ($recipient2 eq "") {$recipient2="                       ";}
####  
# Add leading Zeros, not nice - but works ;-)
  if (index($score,".") < 2){$score="0".$score;}
  if (index($score,".") < 3){$score="0".$score;}
# $sortorder bestimmt die Sortierung:
# 1 - sortiert nach Score (aufsteigend)
# 2 - sortiert nach Datum (aufsteigend)  
# 3 - sortiert nach From (aufsteigend)  
# 4 - sortiert nach To (aufsteigend)  
# 
#  $sortorder1=$sortorder & 127;
   $sortorder1=$sortorder;
# 
#
  if ($sortorder1 == 1) { $scoreliste[$index1]=$score."|".$file; }
  if ($sortorder1 == 2) { 
    $help1=substr($date3,0,8);
    $scoreliste[$index1]=$help1."|".$file; 
  }
  if ($sortorder1 == 3) { $scoreliste[$index1]=$sender2."|".$file; }
 if ($sortorder1 == 4) { 
   #
   $recipient2=~ s/<//;
   $recipient2=~ s/>//;
   $recipient2=~ s/\012//;
   $recipient2=~ s/,//;
   $recipient2=~ s/ //g;
   $scoreliste[$index1]=$recipient2."|".$file; 
 }
#     	 print "<";
#	 print $scoreliste[$index1];
#	 print "> \n";
  $index1++;
}
closedir(BIN);  
$nrofspams=$index1;
#print "-----------------------------------------";
$index1=0;
while ($index1 < $nrofspams){

 # print "$scoreliste[$index1]<TR>\n";
  $index1++;

}


@fileliste=sort{$a cmp $b} @scoreliste;
#if ($sortorder > 128){@fileliste=reverse(@fileliste);}

#print "---------------SORTED--------------------------";


######################
#opendir(BIN, $dir) or die "Can't open $dir: $!";
$index1=0;
while ($index1 < $nrofspams){
   $help1=$fileliste[$index1];
   #
   # !!!
   #
   $file=substr($help1,index($help1,"|")+1,255);
   $hit = 0;
   $subject = "";
   $subject2 = "";
   $sender = "";
   $recipient = "";
   $date = "";
   $hit = 1 if -T "$dir/$file";
       if ($hit == 1) {
          open (EP,"$dir/$file");
          while (<EP>) {
         if (/^From: /i) {
            $_ =~ s/.+<(.+)>/$1/i;

#            $_ =~ s/$1/.+<from:(.+)>/i;
#            $_ =~ s/.*(([A-Z0-9]+[._]?){1,}[A-Z0-9]+\@(([A-Z0-9]+[-]?){1,}[A-Z0-9]+\.){1,}[A-Z]{2,4}).*/$1/i;
#            $_ =~ s/.*(@).*/$1/i;
#            $_ =~ s/.*(\b\[A-Z0-9._%-\]++@\[A-Z0-9._%-\]+\.\[A-Z\]\{2,4\}\b).*/$1/i;
#            $_ =~ s/[ .><]*([0-9a-zA-Z-.]+\@[-.\w]+\.\w{2,3}\W)[ <>.]*/$1/i;
##             $_ = ~ /^From:\s([a-zA-Z0-9._-]+@[a-zA-Z0-9._-]+\.[a-zA-Z0-9._-]+)$/

            $sender = $_;
         }
#         if (/Envelope-To:/i) {
         if (/^To: /i) {
#            $_ =~ s/.+<(.+)>/$1/i;
#            $_ =~ s/$1/<to:(.+)>/i;

            $_ =~ s/.+<(.+)>/$1/i;
            $_ =~ s/to:(.+)/$1/i;
            $recipient = $_;
         }
         if (/^Subject: /i) {
            $_ =~ s/subject:(.+)/$1/i;
            $subject = $_;
         }
         if (/Date:/i) {
            $_ =~ s/date:(.+)/$1/i;
            $date = $_;
         }


          }

          my ($sec, $tm);
          $sec = stat("$dir/$file")->mtime;

          $sender2 =  substr($sender, 0, 30);
          $subject2 =  substr($subject, 14, 70);
          $recipient2 =  substr($recipient, 0, 30);
          $date2 =  substr($date, 6, 21);
          $file2 =  substr($file, 0, 16);
          print "<TR>\n";
          print "<td class='base' align='center'><input type='checkbox' name='$dir/$file.delete' /></td>";
          print "<td class='base' align='center'><input type='checkbox' name='$dir/$file' /></td>";
          print "<td class='base' align='center'><input type='checkbox' name='$dir/$file.whitelist' /></td>";
          print "<td class='base' align='left'>$sender2</td>";
          print "<td class='base' align='left'>$recipient2</td>";
          print "<td class='base' align='left'>$subject2</td>";
          print "<td class='base' align='left'>";

          $tm = localtime($sec);
      printf("%04d-%02d-%02d  %02d:%02d:%02d\n",
          $tm->year+1900, $tm->mon+1, $tm->mday,
          $tm->hour, $tm->min, $tm->sec);
          print "</td>";
          print "<td class='base' align='left'><a href='/proxsmtp_quarantine/$file' target='_blank'>$file2</a></td>";
          print "</TR>";

       }
  $index1++;
    }
    closedir(BIN);
    print <<END
    </table><br /><br />

    <table border='0'>
    <tr><td> del ... </td><td>&nbsp; $Lang::tr{'copfilter send q_mail6'}</td></tr>
    <tr><td> send ... </td><td>&nbsp; $Lang::tr{'copfilter send q_mail4'}</td></tr>
    <tr><td> add &nbsp;... </td><td>&nbsp; $Lang::tr{'copfilter send q_mail5'}</td></tr>
    </table><br /><br />

    <table border='0'>
    <tr><td>
           <input type='checkbox' name='DELETE_ALL_SPAM' /> $Lang::tr{'copfilter send q_mail2'}
       </td>
    </tr>

    <tr><td>
            &nbsp;
       </td>
    </tr>

    <tr><td>
           <input type='submit' name='ACTION' value='$Lang::tr{'copfilter send q_mail'}' />
       </td>

       <td width=15 >
            &nbsp;
       </td>
    </tr>
    </table>
    </form>

END
;

}
else
{
print "<br /><P>$Lang::tr{'copfilter show quarantine error'} \n";
print "/var/log/copfilter/default/opt/proxsmtp/quarantine</P>\n";
}
        &copfilter_stop_log();
}








######### Save settings

if ($copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter save'})
{ 

################################################################################
##   Checking input values
################################################################################

	if ($copfiltersettings{'IMSPECTOR_PROXY_GREEN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'IMSPECTOR_PROXY_ORANGE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'IMSPECTOR_PROXY_BLUE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'IM_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_SCAN_GREEN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_SCAN_ORANGE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_SCAN_BLUE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_VIRUS_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_SPAM_QUARANTINE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_VIRUS_QUARANTINE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_ATTACHMENT_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_SPAM_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_SANITIZE_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_MAIL_REWRITE_SUBJECT'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_MAIL_ADD_HEADER'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_MAIL_ADD_BODY'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_VIRUS_ADMINNOTIF'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SCAN_GREEN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SCAN_ORANGE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SCAN_BLUE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SCAN_RED'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_VIRUS_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SPAM_QUARANTINE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_VIRUS_QUARANTINE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SPAM_QUARANTINE_NOTIFY_USER'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_VIRUS_NOTIFY_USER'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'SMTP_VIRUS_SCAN_BOUNCE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_VIRUS_SCAN_DISCARD'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_ATTACHMENT_SCAN'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'SMTP_ATTACHMENT_SCAN_BOUNCE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_ATTACHMENT_SCAN_DISCARD'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SPAM_SCAN'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'SMTP_SPAM_SCAN_BOUNCE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SPAM_SCAN_DISCARD'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SANITIZE_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_AUTH_ENABLE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'IMAP_ENABLE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'IMAP_DEBUG'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'IMAP_DAILY'} !~ /^(on|off)$/ || 
            $copfiltersettings{'SMTP_MAIL_REWRITE_SUBJECT'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_MAIL_ADD_HEADER'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_MAIL_ADD_BODY'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_VIRUS_ADMINNOTIF'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SPAM_SCAN_SPEEDUP'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'PRIVOXY_ENABLE'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'HTTP_SCAN_GREEN'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'HTTP_SCAN_ORANGE'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'HTTP_SCAN_BLUE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'HTTP_VIRUS_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'MONIT_ENABLE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'FTP_SCAN_GREEN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'FTP_SCAN_ORANGE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'FTP_SCAN_BLUE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'CLAMD_ENABLE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'FPROT_ENABLE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'IMAP_SSL'} !~ /^(on|off)$/ ) 
        {
		$errormessage = $Lang::tr{'copfilter invalid input'};
		goto ERROR;
	} 

#        if ( $copfiltersettings{'IMAP_ENABLE'} eq 'on' && $copfiltersettings{'IMAP_SERVER'} =~ /^$/)
#        {
#                $errormessage = $Lang::tr{'copfilter missing imap_server'};
#                goto ERROR;
#        }

#        if ( $copfiltersettings{'IMAP_ENABLE'} eq 'on' ) {
#        if ( !(&General::validip($copfiltersettings{'IMAP_SERVER'}) || &General::validfqdn($copfiltersettings{'IMAP_SERVER'}) ) ){
#                        $errormessage = $Lang::tr{'copfilter invalid imap_server'};
#                        goto ERROR;  
#        }
#        }

#        if ( $copfiltersettings{'IMAP_ENABLE'} eq 'on' && $copfiltersettings{'IMAP_USER'} eq '' )
#        {
#                $errormessage = $Lang::tr{'copfilter missing imap_user'};
#                goto ERROR;
#        }

#        if ( $copfiltersettings{'IMAP_ENABLE'} eq 'on' && $copfiltersettings{'IMAP_PASS'} eq '' )
#        {
#                $errormessage = $Lang::tr{'copfilter missing imap_pass'};
#                goto ERROR;
#        }
#	if ( $copfiltersettings{'IMAP_ENABLE'} eq 'on' && $copfiltersettings{'IMAP_SPAM_FOLDER'} eq '')
#	{
#		$errormessage = $Lang::tr{'copfilter missing imap_spam_folder'};
#		goto ERROR;
#	}
#	if ( $copfiltersettings{'IMAP_ENABLE'} eq 'on' && $copfiltersettings{'IMAP_NO_SPAM_FOLDER'} eq '')
#	{
#		$errormessage = $Lang::tr{'copfilter missing imap_no_spam_folder'};
#		goto ERROR;
#	} 


        if (!($copfiltersettings{'RULES_DU_JOUR_UPDATE_VALUE'} =~ /^\d+$/) || $copfiltersettings{'RULES_DU_JOUR_UPDATE_VALUE'} <= 0)
        {
                $errormessage = $Lang::tr{'copfilter invalid rules_du_jour time period'};
                goto ERROR;
        }


        if (!($copfiltersettings{'RULES_DU_JOUR_UPDATE_VALUE'} =~ /^\d+$/) || $copfiltersettings{'RULES_DU_JOUR_UPDATE_VALUE'} <= 0)
        {
                $errormessage = $Lang::tr{'copfilter invalid rules_du_jour time period'};
                goto ERROR;
        }


ERROR:
	if ($errormessage) {
		$copfiltersettings{'VALID'} = 'no'; }
	else {
              	$copfiltersettings{'VALID'} = 'yes'; }



################################################################################
##   set update values
################################################################################



        my ($rules_du_jour_updateperiod)=();

        if  ($copfiltersettings{'RULES_DU_JOUR_UPDATE_PERIOD'} eq 'daily') {
        	$rules_du_jour_updateperiod = $copfiltersettings{'RULES_DU_JOUR_UPDATE_VALUE'} * 1440; }
        elsif  ($copfiltersettings{'RULES_DU_JOUR_UPDATE_PERIOD'} eq 'weekly') {
        	$rules_du_jour_updateperiod = $copfiltersettings{'RULES_DU_JOUR_UPDATE_VALUE'} * 10080; }
        elsif  ($copfiltersettings{'RULES_DU_JOUR_UPDATE_PERIOD'} eq 'monthly') {
        	$rules_du_jour_updateperiod = $copfiltersettings{'RULES_DU_JOUR_UPDATE_VALUE'} * 40320; }
        else {
        	$rules_du_jour_updateperiod = $copfiltersettings{'RULES_DU_JOUR_UPDATE_VALUE'} * 60; }

        $rules_du_jour_updateperiod = $rules_du_jour_updateperiod - 5;

        if ($rules_du_jour_updateperiod <= 5) {
        	$rules_du_jour_updateperiod = 5; }

        if ( ! -e "${copfilter_swroot}/etc/rules_du_jour_counter") {
            system("touch ${copfilter_swroot}/etc/rules_du_jour_counter");
            system("chown nobody.nobody ${copfilter_swroot}/etc/rules_du_jour_counter");
        }

        open(FILE, ">/${copfilter_swroot}/etc/rules_du_jour_counter.conf") or die $Lang::tr{'copfilter rules_du_jour_counter'};
        flock(FILE, 2);
        print FILE "$rules_du_jour_updateperiod\n";
        close FILE;



################################################################################
##   purge enable and update files
################################################################################



	if ($copfiltersettings{'VALID'} eq 'yes')
	{

	    unlink "${copfilter_swroot}/etc/spamd_enable";

#	    $copfiltersettings{'SPAMD_ENABLE'} = 'off';
#          if ( ($copfiltersettings{'POP3_SPAM_SCAN'}   eq 'on'    && 
#                 ($copfiltersettings{'POP3_SCAN_GREEN'}  eq 'on'    || 
#                  $copfiltersettings{'POP3_SCAN_ORANGE'} eq 'on  '  ||
#                  $copfiltersettings{'POP3_SCAN_BLUE'}   eq 'on' )) || 
#                 ($copfiltersettings{'SMTP_SPAM_SCAN'}   eq 'on'    && 
#                 ($copfiltersettings{'SMTP_SCAN_GREEN'}  eq 'on'    || 
#                  $copfiltersettings{'SMTP_SCAN_ORANGE'} eq 'on'    ||
#                  $copfiltersettings{'SMTP_SCAN_BLUE'}   eq 'on'    || 
#                  $copfiltersettings{'SMTP_SCAN_RED'}    eq 'on' )))  {
#			$copfiltersettings{'SPAMD_ENABLE'} = 'on';
#			system ('/usr/bin/touch', "${copfilter_swroot}/etc/spamd_enable"); }


          if ($copfiltersettings{'SPAMD_ENABLE'} eq 'on') {
			system ('/usr/bin/touch', "${copfilter_swroot}/etc/spamd_enable"); }




# if setting were valid, write settings and reconfigure

         &writehashsorted("${copfilter_swroot}/etc/global_settings", \%copfiltersettings);

        if ( ! ($copfiltersettings{'SKIP_RESTART'} eq 'on' )) {
            &copfilter_start_log(); 
            print "<br /><b>$Lang::tr{'copfilter restart0'} spamd..</b> <br />";
            system('/usr/local/bin/copfilter_restartspamd');
            print "<br /><b>$Lang::tr{'copfilter restart0'} monit..</b> <br />";
            system('/usr/local/bin/copfilter_restartmonit');
            &copfilter_stop_log(); 
        }
        else {
            $copfiltersettings{'ACTION'} = '';
        }


        }
        else {
            $copfiltersettings{'ACTION'} = '';
        }


}






################################################################################
##  Website - Information
################################################################################


#for testing purposes only
#&General::writehash("/tmp/settings", \%copfiltersettings);

if ($copfiltersettings{'ACTION'} eq '')
{

&Header::openbigbox('100%', 'left', '', $errormessage);


if ($errormessage) {
    &Header::openbox('100%', 'left', $Lang::tr{'copfilter error messages'});
    #print "<class name='base'><font color='${Header::colourred}'>$errormessage\n</font>";
    print "<font class='base'>$errormessage&nbsp;</font>\n";
    &Header::closebox();
}

print            "$copfiltersettings{'ACTION'}";

################################################################################
##  Website - AntiSpam
################################################################################

my $output = `/etc/rc.d/init.d/copfilter_spamd pid weboutput`;
my $status = "";
if ( $output =~ /OFF/ ) { $status="<td width='180' height='20' bgcolor='#C01327' align='center' ><font color='#FFFFFF'size='2.7em'><b> STOPPED <\/b><\/font>"; }
if ( $output =~ /NOT ACTIVATED/ ) { $status="<td width='180' height='20' bgcolor='#A8A8A8' align='center' ><font size='2.7em'><b> NOT ACTIVATED <\/b><\/font>";; }
if ( $output =~ /ON/ ) { $status="<td width='180' height='20' bgcolor='#339933' align='center' ><font size='2.7em'><b> RUNNING <\/b><\/font>";; }

print "<a name='antispam'/>";
&Header::openbox('100%', 'left', "$Lang::tr{'copfilter antispam'} (SpamAssassin, P3PMail, RulesDuJour):");


#############################################################################3

my @longmonths = ( $Lang::tr{'copfilter january'}, $Lang::tr{'copfilter february'}, $Lang::tr{'copfilter march'},
    $Lang::tr{'copfilter april'}, $Lang::tr{'copfilter may'}, $Lang::tr{'copfilter june'}, 
    $Lang::tr{'copfilter july'}, $Lang::tr{'copfilter august'}, $Lang::tr{'copfilter september'}, 
    $Lang::tr{'copfilter october'}, $Lang::tr{'copfilter november'}, $Lang::tr{'copfilter december'} );

my %cgiparams=();

#my @now = localtime();
#
#use POSIX();
#use Time::localtime;
#use Time::HiRes;
#
#my ($sec, $tm);
#print "XXX $now[4] $now[3]";
#print "XXX $tm[4]";
#
#if (!($cgiparams{'MONTH'} =~ /^(0|1|2|3|4|5|6|7|8|9|10|11)$/) ||
#    !($cgiparams{'DAY'} =~ /^(1|2|3|4|5|6|7|8|9|10|11|12|13|14|15|16|17|18|19|20|21|22|23|24|25|26|27|28|29|30|31)$/)) {
#    # Reports are generated at the end of the day, so if nothing is selected
#    # we need to display yesterdays (todays won't have been generated yet)
#    my @temp_then=();
#    my @temp_now = localtime(time);
#    $temp_now[4] = $now[4];
#    $temp_now[3] = $now[3];
#    @temp_then = localtime(POSIX::mktime(@temp_now) - 86400);
#       ## Retrieve the same time on the previous day -
#       ## 86400 seconds in a day
#    $cgiparams{'MONTH'} = $temp_then[4];
#    $cgiparams{'DAY'} = $temp_then[3];
#}

#my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst);
#($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
#print "XX$sec";
#print "YY$min";
#print "ZZ$hour";
#$year = sprintf("%02d", $year % 100);
#print "$year";

print <<END;
<table width='100%' border='0' cellpadding='5'>
<tr>
	<td nowrap width='14%'></td>
	<td nowrap width='14%'></td>
	<td nowrap width='72%'></td>
</tr>
<tr>
    <td nowrap><font size='2.7em'><b>SpamAssassin Status:</b></td>
	$status
END
;

if ( $nbr_spams gt 0){
	print "<td nowrap align='right'> <b><font size='2.7em' color='#810000'>$Lang::tr{'copfilter spam_in_quarantine1'}$nbr_spams$Lang::tr{'copfilter spam_in_quarantine2'}</font></b> </td>";}

print <<END
</tr>
<tr>
<td height='25'> &nbsp; </td>
</tr>
</table>
END
;

undef %cgiparams;
&resetCgiParams();

sub resetCgiParams
{
    $cgiparams{'MONTH'}              = 0;
    $cgiparams{'YEAR'}               = 0;
    $cgiparams{'DAY'}                = 0;
    return;
}

print "<br><br>";
print "$Lang::tr{'copfilter spamstats_long'} &nbsp; &nbsp;   $Lang::tr{'copfilter spamstats'}\n<br /><br />\n";
print "<form method='post' action='/cgi-bin/spamstats_month.pl'>\n";
print "$Lang::tr{'copfilter year'}:\n";
print "<select name='YEAR'>\n";
for (my $year = 2013; $year < 2020; $year++)
{
    print "\t<option ";
    print "value='$year'>$year</option>\n";
}
print "</select>\n";
print "&nbsp; $Lang::tr{'copfilter month'}:\n";
print "<select name='MONTH'>\n";
for (my $month = 0; $month < 12; $month++)
{
    print "\t<option ";
    if ($month == $cgiparams{'MONTH'}) {
        print "selected='selected' "; }
    print "value='$month'>$longmonths[$month]</option>\n";
}
print "</select>\n";
print "&nbsp; <input type='submit' name='ACTION' value='$Lang::tr{'copfilter show'}'>\n";
print "</form>\n";



print "<form method='post' action='/cgi-bin/spamstats_day.pl'>";
print "&nbsp; &nbsp; $Lang::tr{'copfilter year'}:\n";
print "<select name='YEAR'>\n";
for (my $year = 2013; $year < 2020; $year++)
{
    print "\t<option ";
    print "value='$year'>$year</option>\n";
}
print "</select>\n";
print "&nbsp; $Lang::tr{'copfilter month'}:\n";
print "<select name='MONTH'>\n";
for (my $month = 0; $month < 12; $month++)
{
    print "\t<option ";
    if ($month == $cgiparams{'MONTH'}) {
        print "selected='selected' "; }
    print "value='$month'>$longmonths[$month]</option>\n";
}
print "</select>\n";
print "&nbsp; $Lang::tr{'copfilter day'}:\n";
print "<select name='DAY'>\n";
for (my $day = 1; $day <= 31; $day++)
{
    print "\t<option ";
    if ($day == $cgiparams{'DAY'}) {
        print "selected='selected' "; }
    print "value='$day'>$day</option>\n";
}
print "</select>\n";
print "&nbsp; <input type='submit' name='ACTION' value='$Lang::tr{'copfilter show'}'>\n";
print "</form>\n";




#############################################################################3
print "<form method='post' action='/cgi-bin/copfilter_antispam.cgi' enctype='multipart/form-data'>";
print <<END

<br />
<table border='0' cellpadding='5'>
<tr>
        <td width='160'></td>
        <td width='160'></td>
        <td width='30'></td>
        <td width='160'></td>
        <td></td>
</tr>




<tr><td><u><b>SpamAssassin:</b></u></td></tr>

<tr>
        <td> $Lang::tr{'copfilter spamd_enable'}</td>
        <td> <select name='SPAMD_ENABLE'>
             <option value='on' $selected{'SPAMD_ENABLE'}{'on'}>on</option>
             <option value='off' $selected{'SPAMD_ENABLE'}{'off'}>off</option> </select></td>
        <td></td>
        <td align='left' colspan='2'> $Lang::tr{'copfilter whitelist manager'} <br />
        $Lang::tr{'copfilter digest manager'}</td>

</tr>
<tr>
        <td>$Lang::tr{'copfilter smtp_spamscan_level'}</td>
                <td colspan='1'> <select name='SPAM_SCAN_SCORE_LEVEL'>
END
;
                for(my $i = 3; $i <= 40; $i++)
                {
                   print "<option value='$i' $selected{'SPAM_SCAN_SCORE_LEVEL'}{$i}>$i</option>";
                }
print <<END
        </select> </td>
        <td></td>
        <td> $Lang::tr{'copfilter increase spam scan speed'}</td>
        <td> <select name='SPAM_SCAN_SPEEDUP'>
             <option value='on' $selected{'SPAM_SCAN_SPEEDUP'}{'on'}>on</option>
             <option value='off' $selected{'SPAM_SCAN_SPEEDUP'}{'off'}>off</option> </select></td>
</tr>

<tr>
        <td>$Lang::tr{'copfilter daily spam digest'}</td>
        <td>
             <select name='SPAM_DAILY_DIGEST'>
             <option value='on' $selected{'SPAM_DAILY_DIGEST'}{'on'}>on</option>
             <option value='off' $selected{'SPAM_DAILY_DIGEST'}{'off'}>off</option> </select> </td>
        <td>&nbsp;</td>
        <td> RBL Check\'s <br />(slows down scan\'s)</td>
        <td> <select name='SPAM_SCAN_RBL'>
             <option value='on' $selected{'SPAM_SCAN_RBL'}{'on'}>on</option>
             <option value='off' $selected{'SPAM_SCAN_RBL'}{'off'}>off</option> </select></td>
<!--        <td>$Lang::tr{'copfilter german rules'}</td>
        <td>
             <select name='RULES_GERMAN_ENABLE'>
             <option value='on' $selected{'RULES_GERMAN_ENABLE'}{'on'}>on</option>
             <option value='off' $selected{'RULES_GERMAN_ENABLE'}{'off'}>off</option> </select> </td> -->
</tr>
<tr>
    <td>&nbsp; </td>
</tr>
<tr><td><u><b>SpamAssassin Bayes:</b></u></td></tr>

<tr>
        <td> $Lang::tr{'copfilter imap_enable'}:&nbsp; </td>
        <td> <select name='IMAP_ENABLE'>
             <option value='on' $selected{'IMAP_ENABLE'}{'on'}>on</option>
             <option value='off' $selected{'IMAP_ENABLE'}{'off'}>off</option> </select></td>
        <td> </td>
<!--
        <td> $Lang::tr{'copfilter imap_debug'}:&nbsp; </td>
        <td> <select name='IMAP_DEBUG'>
             <option value='on' $selected{'IMAP_DEBUG'}{'on'}>on</option>
             <option value='off' $selected{'IMAP_DEBUG'}{'off'}>off</option> </select></td>
-->

</tr>

<tr>
        <td>$Lang::tr{'copfilter spamd_bayes_00'}</td>
                <td colspan='1'> <select name='SPAM_SCORE_BAYES_00'>
END
;
                for(my $j = -50; $j <= -10; $j++)
                {
                	my $jj = sprintf("%.3f",($j / 10));
                	print "<option value='$jj' $selected{'SPAM_SCORE_BAYES_00'}{$jj}>$jj</option>";
                }
print <<END
        </select> </td>
        <td></td>

        <td>$Lang::tr{'copfilter spamd_bayes_05'}</td>
               <td colspan='1'> <select name='SPAM_SCORE_BAYES_05'>
END
;
                for(my $k = -40; $k <= 0; $k++)
                {
                	my $kk = sprintf("%.3f",($k / 10));
                	print "<option value='$kk' $selected{'SPAM_SCORE_BAYES_05'}{$kk}>$kk</option>";
                }
print <<END
        </select> </td>
        <td></td>
</tr>

<tr>
        <td>$Lang::tr{'copfilter spamd_bayes_20'}</td>
                <td colspan='1'> <select name='SPAM_SCORE_BAYES_20'>
END
;
                for(my $l = -30; $l <= 10; $l++)
                {
                	my $ll = sprintf("%.3f",($l / 10));
                	print "<option value='$ll' $selected{'SPAM_SCORE_BAYES_20'}{$ll}>$ll</option>";
                }
print <<END
        </select> </td>
        <td></td>

        <td>$Lang::tr{'copfilter spamd_bayes_40'}</td>
                <td colspan='1'> <select name='SPAM_SCORE_BAYES_40'>
END
;
                for(my $m = -20; $m <= 20; $m++)
                {
                	my $mm = sprintf("%.3f",($m / 10));
                	print "<option value='$mm' $selected{'SPAM_SCORE_BAYES_40'}{$mm}>$mm</option>";
                }
print <<END
        </select> </td>
        <td></td>
</tr>

<tr>
        <td>$Lang::tr{'copfilter spamd_bayes_50'}</td>
                <td colspan='1'> <select name='SPAM_SCORE_BAYES_50'>
END
;
                for(my $n = 0; $n <= 40; $n++)
                {
                	my $nn = sprintf("%.3f",($n / 10));
                	print "<option value='$nn' $selected{'SPAM_SCORE_BAYES_50'}{$nn}>$nn</option>";
                }
print <<END
        </select> </td>
        <td></td>

        <td>$Lang::tr{'copfilter spamd_bayes_60'}</td>
                <td colspan='1'> <select name='SPAM_SCORE_BAYES_60'>
END
;
                for(my $o = 10; $o <= 50; $o++)
                {
                	my $oo = sprintf("%.3f",($o / 10));
                	print "<option value='$oo' $selected{'SPAM_SCORE_BAYES_60'}{$oo}>$oo</option>";
                }
print <<END
        </select> </td>
        <td></td>
</tr>

<tr>
        <td>$Lang::tr{'copfilter spamd_bayes_80'}</td>
                <td colspan='1'> <select name='SPAM_SCORE_BAYES_80'>
END
;
                for(my $p = 15; $p <= 70; $p++)
                {
                	my $pp = sprintf("%.3f",($p / 10));
                	print "<option value='$pp' $selected{'SPAM_SCORE_BAYES_80'}{$pp}>$pp</option>";
                }
print <<END
        </select> </td>
        <td></td>

        <td>$Lang::tr{'copfilter spamd_bayes_95'}</td>
               <td colspan='1'> <select name='SPAM_SCORE_BAYES_95'>
END
;
                for(my $q = 25; $q <= 80; $q++)
                {
                	my $qq = sprintf("%.3f",($q / 10));
                	print "<option value='$qq' $selected{'SPAM_SCORE_BAYES_95'}{$qq}>$qq</option>";
                }
print <<END
        </select> </td>
        <td></td>
</tr>
<tr>
        <td>$Lang::tr{'copfilter spamd_bayes_99'}</td>
                <td colspan='1'> <select name='SPAM_SCORE_BAYES_99'>
END
;
                for(my $r = 35; $r <= 90; $r++)
                {
                	my $rr = sprintf("%.3f",($r / 10));
                	print "<option value='$rr' $selected{'SPAM_SCORE_BAYES_99'}{$rr}>$rr</option>";
                }
print <<END
        </select> </td>
        <td></td>
</tr>


<tr>
        <td> $Lang::tr{'copfilter imap_daily'}:&nbsp; </td>
        <td> <select name='IMAP_DAILY'>
             <option value='on' $selected{'IMAP_DAILY'}{'on'}>on</option>
             <option value='off' $selected{'IMAP_DAILY'}{'off'}>off</option> </select> </td>
        <td> </td>
        <td>$Lang::tr{'copfilter imap_user'}:&nbsp; </td>
        <td> <input type='text' size="15" name='IMAP_USER' value='$copfiltersettings{'IMAP_USER'}' /></td>

<tr>
        <td>$Lang::tr{'copfilter imap_server'}:&nbsp; </td>
        <td><input type='text' size="20" name='IMAP_SERVER' value='$copfiltersettings{'IMAP_SERVER'}' /> </td>
        <td> </td>
        <td>$Lang::tr{'copfilter imap_pass'}:&nbsp;</td>
        <td><input type='password' size="15" name='IMAP_PASS' value='$copfiltersettings{'IMAP_PASS'}' /> 
</tr>
<tr>
        <td>$Lang::tr{'copfilter imap_ssl'}:&nbsp; </td>
        <td><select name='IMAP_SSL'>
             <option value='on' $selected{'IMAP_SSL'}{'on'}>on</option>
             <option value='off' $selected{'IMAP_SSL'}{'off'}>off</option> </select> </td>
        <td> </td>
        <td> </td>
</tr>
<!--
<tr>
	<td>$Lang::tr{'copfilter imap_spam_dir'}:&nbsp; </td>
	<td><input type='text' size="20" name='IMAP_SPAM_DIR' value='$copfiltersettings{'IMAP_SPAM_DIR'}' /></td>
	<td> </td>
	<td>$Lang::tr{'copfilter imap_dir_amp'}:&nbsp; </td>
        <td> <select name='IMAP_DIR_AMP'>
             <option value='on' $selected{'IMAP_DIR_AMP'}{'on'}>on</option>
             <option value='off' $selected{'IMAP_DIR_AMP'}{'off'}>off</option> </select></td>
</tr>
-->
<tr>
	<td>$Lang::tr{'copfilter imap_spam_folder'}:&nbsp; </td>
	<td><input type='text' size="15" name='IMAP_SPAM_FOLDER' value='$copfiltersettings{'IMAP_SPAM_FOLDER'}' /></td>
	<td> </td>
	<td>$Lang::tr{'copfilter imap_no_spam_folder'}:&nbsp; </td>
    <td><input type='text' size="20" name='IMAP_NO_SPAM_FOLDER' value='$copfiltersettings{'IMAP_NO_SPAM_FOLDER'}'/></td>
	<td colspan='3'> </td>
</tr>
END
;
if ( -e "${copfilter_swroot}/etc/copfilter_imap_run_now.done" ){
   print "<font color='#339933'>DONE</font>";
   system ('/bin/rm', "${copfilter_swroot}/etc/copfilter_imap_run_now.done");
}
print <<END

        </td>
</tr>

<tr>
        <td colspan='5'>$Lang::tr{'copfilter imap_des'}</td>
	<td>&nbsp;</td>
</tr>
</table>

<br />

<!--

<table border='0' cellpadding='5'>
<tr><td><u><b>$Lang::tr{'copfilter sanitizer'}:</b></u></td></tr>
<tr>
	<td> $Lang::tr{'copfilter sanitizer method'}</td>
        <td>
             <select name='SANITIZE_METHOD'>
             <option value='ANOMY' $selected{'SANITIZE_METHOD'}{'ANOMY'}>Anomy</option>
             <option value='P3PMAIL' $selected{'SANITIZE_METHOD'}{'P3PMAIL'}>P3PMail</option> </select></td>
	<td> &nbsp;</td>
	<td colspan='2'>$Lang::tr{'copfilter sanitizer2'}</td>
</tr>

</table>
-->



<table width='100%' border='0' cellpadding='2'>
<tr>
        <td width='28%'></td>
        <td width='5%'></td>
        <td width='23%'></td>
        <td width='24%'></td>
        <td width='20%'></td>
</tr>
<tr>
        <td>&nbsp;</td>
</tr>
<!--
<tr>
	<td colspan='4'><u><b>SARE Rules from Openprotect.com:</b></u> &nbsp; &nbsp; &nbsp;
       	     <select name='RULES_DU_JOUR_ENABLE'>
             <option value='on' $selected{'RULES_DU_JOUR_ENABLE'}{'on'}>on</option>
             <option value='off' $selected{'RULES_DU_JOUR_ENABLE'}{'off'}>off</option> </select>
             $Lang::tr{'copfilter rules_du_jour1'}
	 </td>
</tr>
-->
<tr>
        <td>&nbsp;</td>
</tr>
<tr>
        <td colspan='2'><b>$Lang::tr{'copfilter spamd_update'}:</b></td>
        <td colspan='2'><b>$Lang::tr{'copfilter automatic update'}:</b></td>
        <td colspan='1'><b>$Lang::tr{'copfilter manual update'}:</b></td>
</tr>

<tr>
        <td colspan='2' valign='top'>
END
;

############# rules info start ############
my $current = '';

##### spamassasasin original #####
if ( -e "/var/log/copfilter/default/opt/mail-spamassassin/etc/mail/spamassassin/updates_spamassassin/updates_spamassassin_org.cf" ){
$output = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/mail-spamassassin/etc/mail/spamassassin/updates_spamassassin/ |grep updates_spamassassin_org.cf | sed 's/  */ /g' | cut -d " " -f 6-7`;
$output = "<br>$output $Lang::tr{'copfilter spam_rules1'}";
}else{
$output = '';}

if ($output ne ''){
$current = "<b>$Lang::tr{'copfilter spam_rules0'}</b>";
print "$current";
print "$output";}

##### SARE openprotect #####
if ( -e "/var/log/copfilter/default/opt/mail-spamassassin/etc/mail/spamassassin/updates_spamassassin/saupdates_openprotect_com.cf" ){
$output = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/mail-spamassassin/etc/mail/spamassassin/updates_spamassassin/ |grep saupdates_openprotect_com.cf | sed 's/  */ /g' | cut -d " " -f 6-7`;
$output = "<br>$output $Lang::tr{'copfilter spam_rules2'}";
}else{
$output = '';}


if ($output ne ''){
if ($current eq ''){
$current = "<b>$Lang::tr{'copfilter spam_rules0'}</b>";
print "$current";}
print "$output";}

##### MBL #####
if ( -e "/var/log/copfilter/default/opt/mail-spamassassin/etc/mail/spamassassin/updates_spamassassin/10_MBL.cf" ){
$output = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/mail-spamassassin/etc/mail/spamassassin/updates_spamassassin/ |grep 10_MBL.cf | sed 's/  */ /g' | cut -d " " -f 6-7`;
$output = "<br>$output $Lang::tr{'copfilter spam_rules3'}";
}else{
$output = '';}


if ($output ne ''){
if ($current eq ''){
$current = "<b>$Lang::tr{'copfilter spam_rules0'}</b>";
print "$current";}
print "$output";}

##### zmi_german #####
if ( -e "/var/log/copfilter/default/opt/mail-spamassassin/etc/mail/spamassassin/updates_spamassassin/70_zmi_german.cf" ){
$output = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/mail-spamassassin/etc/mail/spamassassin/updates_spamassassin/ |grep 70_zmi_german.cf | sed 's/  */ /g' | cut -d " " -f 6-7`;
$output = "<br>$output $Lang::tr{'copfilter spam_rules4'}";
}else{
$output = '';}


if ($output ne ''){
if ($current eq ''){
$current = "<b>$Lang::tr{'copfilter spam_rules0'}</b>";
print "$current";}
print "$output";}

##### mime_validate #####
if ( -e "/var/log/copfilter/default/opt/mail-spamassassin/etc/mail/spamassassin/updates_spamassassin/mime_validate.cf" ){
$output = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/mail-spamassassin/etc/mail/spamassassin/updates_spamassassin/ |grep mime_validate.cf | sed 's/  */ /g' | cut -d " " -f 6-7`;
$output = "<br>$output $Lang::tr{'copfilter spam_rules5'}";
}else{
$output = '';}


if ($output ne ''){
if ($current eq ''){
$current = "<b>$Lang::tr{'copfilter spam_rules0'}</b>";
print "$current";}
print "$output";}


##### add other rules if available ######
############# rules info end ############
my $nextupd = '';
if ( -e "${copfilter_swroot}/etc/rules_du_jour_counter" && $copfiltersettings{'RULES_DU_JOUR_UPDATE_METHOD'} eq 'periodically' ){
my $nexttime = 0;
my $nextday = 0;
my $nexthour = 0;
my $nextminute = 0;
$nexttime = `cat /var/log/copfilter/default/etc/rules_du_jour_counter` + 5;

$nextday = ($nexttime - $nexttime % 1440) / 1440;
$nexthour = ($nexttime % 1440 - $nexttime % 1440 % 60) / 60;
$nextminute = $nexttime - $nextday * 1440 - $nexthour * 60;

if ($nextday > 0){
if ($nexthour < 10 ){ $nexthour = "0$nexthour"; }
if ($nextminute < 10){ $nextminute = "0$nextminute"; }
$nextupd = "<br><br><b>$nextday:$nexthour:$nextminute $Lang::tr{'copfilter days'} $Lang::tr{'copfilter_sa_rules_updnext'} </b>";
}elsif($nexthour > 0){
if ($nextminute < 10){ $nextminute = "0$nextminute"; }
$nextupd = "<br><br><b>$nexthour:$nextminute $Lang::tr{'copfilter hours'} $Lang::tr{'copfilter_sa_rules_updnext'} </b>";
}else{
$nextupd = "<br><br><b>$nextminute $Lang::tr{'copfilter minutes'} $Lang::tr{'copfilter_sa_rules_updnext'} </b>";}}

$output = '';
$output = `cat /var/log/copfilter/default/opt/tools/bin/check-updates_rulesdujour.sh | grep "RDJ_VERSION" | cut -d "=" -f2`;

if ($output ne ''){
$output = "<br><br><b>$Lang::tr{'copfilter rules_du_jour des'} $Lang::tr{'copfilter version'} $output</b>";}

print <<END
</td> 
        <td valign='top'><input type='radio' name='RULES_DU_JOUR_UPDATE_METHOD' value='periodically' $selected{'RULES_DU_JOUR_UPDATE_METHOD'}{'periodically'} />$Lang::tr{'copfilter enabled every'}: <br />
        <input type='radio' name='RULES_DU_JOUR_UPDATE_METHOD' value='manually' $selected{'RULES_DU_JOUR_UPDATE_METHOD'}{'manually'} />$Lang::tr{'copfilter disabled'}
	$nextupd$output</td>
        <td valign='top'><input type='text' name='RULES_DU_JOUR_UPDATE_VALUE' size='3' maxlength='3' value='$copfiltersettings{'RULES_DU_JOUR_UPDATE_VALUE'}' />
        <select name='RULES_DU_JOUR_UPDATE_PERIOD'>
                <option value='daily' $selected{'RULES_DU_JOUR_UPDATE_PERIOD'}{'daily'}>$Lang::tr{'copfilter days'}</option>
                <option value='weekly' $selected{'RULES_DU_JOUR_UPDATE_PERIOD'}{'weekly'}>$Lang::tr{'copfilter weeks'}</option>
                <option value='monthly' $selected{'RULES_DU_JOUR_UPDATE_PERIOD'}{'monthly'}>$Lang::tr{'copfilter months'}</option>
        </select></td>
        <td valign='top'><input type='submit' name='ACTION' value='$Lang::tr{'copfilter rules_du_jour update now'}' />
END
;
if ( -e "${copfilter_swroot}/etc/copfilter_check-updates_rules_du_jour.done" ){
   print "<font color='#339933'>DONE</font>";
   system ('/bin/rm', "${copfilter_swroot}/etc/copfilter_check-updates_rules_du_jour.done");
}

print <<END

	</td>
</tr>
<tr>
        <td colspan='3'>$Lang::tr{'copfilter antispam restart'} <br /> $Lang::tr{'copfilter automatic update email'} </td> 
</tr>
<tr>
        <td nowrap valign='bottom' colspan='2'>
            <input type='checkbox' name='SKIP_RESTART'>
             $Lang::tr{'copfilter skip restart'}
        <br>
        <input type='submit' name='ACTION' value='$Lang::tr{'copfilter save'}' /> </td>
        <td nowrap> </td>
        <td nowrap> </td>
        <td nowrap valign='bottom'> <input type='submit' name='ACTION' value='$Lang::tr{'copfilter show spam quarantine'}'>
END
;
	if ( $nbr_spams gt 0){
	print "<b>&nbsp; (${nbr_spams}x)</b><img src='/images/copfilter-logo.png' width='120' height='48' alt='*'></td>";
	}else{
	print "<img src='/images/copfilter-logo.png' width='120' height='48' alt='*'></td>";}
print <<END
</tr>
</table>
END
;

print "</form>\n";
print "<br />\n";

&Header::closebox();

system('rm -f /tmp/count.aid >/dev/null 2>&1');

# For Testing
#print "<pre>";
#$output = `cat /var/log/copfilter/default/etc/global_settings`;
#print "$output\n";
#print "</pre>";
&Header::closebigbox();

&Header::closepage();


}
